##############################################################
#                                                            #
#                       LIQUID WEATHER ++                    #
#                                                            #
#   Copyright:Matthew - dmbkiwi@yahoo.com                    #
#   License:  GPL2                                           #
#   A superkaramba theme                                     #
#                                                            #
##############################################################

#this import statement allows access to the karamba functions
import karamba
import os
import string
import time
import urllib
import urllib2
from os.path import expanduser
import copy
from threading import *
import sys
from gettext import GNUTranslations
from StringIO import StringIO
import zipfile
from datetime import datetime

#hasqt = 0
# Configuration
#
# YOU DONT NEED TO EDIT ANYTHING HERE.  DO IT FROM WITHIN THE PROGRAM
#
# I REPEAT -
#
#
# You don't need to edit ANYTHING.  Just run the widget and use the
# "Configure Theme" submenu to change everything


# SETUP URL'S TO DOWNLOAD WEATHER DATA
#
# URL's to download weather data:

foo = sys.stdout.encoding
bar = sys.stdin.encoding
url = 'http://xoap.weather.com/weather/local/NZXX0049?cc=*&dayf=5&prod=xoap&par=1003666583&key=4128909340a9b2fc'
url_base_addr = 'http://xoap.weather.com/weather/local/'
url_suffix = '?cc=*&dayf=5&prod=xoap&par=1003666583&key=4128909340a9b2fc'
url_bbc_base_addr = 'http://www.bbc.co.uk/print/weather/5day.shtml?world='
url_bbc_add_addr =  '&print'
#
# URL for webcam:
webcamurls = ['http://homepages.ihug.co.nz/%7Eseebee/webcam/wgtn_harbour.jpg']
#
#
# Where the cached copy of the html page
# should be kept:
installed = '~/.superkaramba'

# SETUP SOME BASIC VARIABLES WITH DEFAULT VALUES:

# DAVE
cities = []
codes = []

wdlThread = None
set_gui_failed = 1
metric_units = 0
days = 5
clock = 0
threadflag = 1
dnamobst = 0
order = 0
separator = "/"
#
# This is the initial background if not set in the config file:
mainback = "bg1.png"
#
# If 1, then wind arrows point towards where the wind is blowing to:
windy = 0
webcamlabels = ['Wellington Harbour']
nowebcams = 0
timegate = 0
configchange = 0
webbypic = None
satpic = None
webcams = 0
webcamdisplay = 0
whichone = 0
use_wcom = 1
wcomcode = 'NZXX0049'
satpicon = 0
sumpicon = 0
presspicon = 0
iconset = 'Liquid'
animate = 0
iconsetpath = 'icons/' + iconset + '/'
flatflag = 0
flatstring = ''
werethreading = 0
colour = 'black'
altback = 0
delay = 0
kxdocker = 0
kxdocker_running = 0
kxdocker_lasttime = 0
red = 0
green = 0
blue = 0
reddrop = 0
greendrop = 0
bluedrop = 0
dropdownflag = 0
animstyle = 0
textstyle = 0
moonon = 0
animdelay = 0.01
language = ''
# DAVE - testing change
#delaylist = [3600.0, 7200.0, 10800.0]
delaylist = [3600000, 7200000, 10800000]
gui_file_stat = None
data_updated = 0
change_flag = 1
font_range = 'verdana'
prefix = 'http://maps.wunderground.com/data/640x480/'
forecastprefix = 'http://www.accuweather.com/adc_images2/english/forecast/tmpicn/640x480/'
forelocations = ['namer_todtmpicn.gif','camer_todtmpicn.gif','samer_todtmpicn.gif', 'eur_todtmpicn.gif','asia_todtmpicn.gif','afr_todtmpicn.gif','au_todtmpicn.gif','rs_todtmpicn.gif']
eq_win = ['650x720', '650x720', '650x720', '650x890', '650x700', '650x780', '650x890']
gui_on = 0
shadow = 0
stormFlag = 0
stormon = 0
abouton = 0
connect_warn = 0
version = "12.5.1"
UI = 'complex'
haveiconpath = 0
home_directory = os.popen("echo $HOME").readline()[0:-1]
try:
    os.mkdir(home_directory + '/.superkaramba/lwp')
except(OSError):
    pass
try:
    os.mkdir(home_directory + '/.superkaramba/lwp/fade')
except(OSError):
    pass
try:
    os.mkdir(home_directory + '/.superkaramba/lwp/background')
except(OSError):
    pass

config_directory = home_directory + '/.superkaramba/lwp'
encoding = 'iso-8859-1'
#ddbg = "background/dd_bg.png"
#ddcbg = "background/ddc_bg.png"
#hbg = "background/h_bg.png"
#hbg2 = "background/h_bg.png"
havebkgdpath = 0
bkgd_set = 'Stippled White Raised'
bkgd_dir = 'NoDir'
base_bkgd = ['Plain Gray Flat (1)', 'Plain Gray Flat (2)', 'Plain Gray Raised (1)', 'Plain Gray Raised (2)', 'Plain White Flat (1)', 'Plain White Flat (2)', 'Plain White Raised (1)', 'Plain White Raised (2)', 'Stippled White Raised']
moon_map = {'New':'1.png','New Moon':'1.png','Waxing Crescent':'2.png','First Quarter':'3.png','Waxing Gibbous':'4.png','Full':'5.png','Full Moon':'5.png','Waning Gibbous':'6.png','Last Quarter':'7.png','Waning Crescent':'8.png'}
bg = config_directory + '/background/bg.png'
ddbg = config_directory + '/background/dd_bg.png'
ddcbg = config_directory + '/background/ddc_bg.png'
hbg = config_directory + '/background/hbg.png'
hbg2 = config_directory + '/background/hbg.png'
fontFamilyMatrix = ['Arial Black','Verdana','Verdana','Arial Black','Arial Black']
fontSizeMatrix = [20,12,10,12,10]
# DAVE
class weatherDL(Thread):
    w = None
    h = None
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        wData = getWeather(self.widget)
        self.w = wData[0]
        self.h = wData[1]

class initBeginKxdocker(Thread):
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        sep = weather.get_forecast(0).temp_range().find('/')
        if (iconset == 'Liquid') or (iconset == 'Umicons'):
            curricon = karamba.readThemeFile(widget, iconsetpath + weather.icon_path())
        else:
            curricon = open(iconsetpath + weather.icon_path(),'r')
            curricon = curricon.read()
        icon_file = open(config_directory + '/kxdico_curr','w')
        print >> icon_file, curricon
        icon_file.close()
        for i in range(5):
            if (iconset == 'Liquid') or (iconset == 'Umicons'):
                icon_img = karamba.readThemeFile(widget, iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons', 'large_icons'))
            else:
                curricon = open(iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons', 'large_icons'),'r')
                icon_img = curricon.read()
            icon_file = open(config_directory + '/kxdico_' + str(i),'w')
            print >> icon_file, icon_img
            icon_file.close()
        day1txt = _('Today:')
        day1tmp = weather.get_forecast(0).temp_range()
        if base_menuime >= 14:
            day1txt = _('Tonight:')
            day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
        os.system('dcop kxdocker docker addIcon Current %s "%s : %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_curr', situtext.encode(encoding), weather.temperature()))
        os.system('dcop kxdocker docker changeEncodedTextByName Current "%s" %s' %(situtext.encode(encoding) + ' : ' + weather.temperature(),encoding))
        os.system('dcop kxdocker docker addIcon For1 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_0', day1txt.encode(encoding), day1tmp))
        os.system('dcop kxdocker docker changeEncodedTextByName For1 "%s" %s' %(day1txt.encode(encoding) + ' ' + day1tmp,encoding))
        os.system('dcop kxdocker docker addIcon For2 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_1', _(weather.get_forecast(1).weekday()).encode(encoding) + ":", weather.get_forecast(1).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For2 "%s" %s' %(_(weather.get_forecast(1).weekday()).encode(encoding) + ":" + weather.get_forecast(1).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For3 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_2', _(weather.get_forecast(2).weekday()).encode('utf-8') + ":", weather.get_forecast(2).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For3 "%s" %s' %(_(weather.get_forecast(2).weekday()).encode(encoding) + ":" + weather.get_forecast(2).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For4 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_3', _(weather.get_forecast(3).weekday()).encode('utf-8') + ":", weather.get_forecast(3).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For4 "%s" %s' %(_(weather.get_forecast(3).weekday()).encode(encoding) + ":" + weather.get_forecast(3).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For5 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_4', _(weather.get_forecast(4).weekday()).encode('utf-8') + ":", weather.get_forecast(4).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For5 "%s" %s' %(_(weather.get_forecast(4).weekday()).encode(encoding) + ":" + weather.get_forecast(4).temp_range(),encoding))
        kxdocker_lasttime = 1

class initKxdocker(Thread):
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        sep = weather.get_forecast(0).temp_range().find('/')
        icopath = iconsetpath + weather.icon_path()
        day1txt = _('Today:')
        day1tmp = weather.get_forecast(0).temp_range()
        if base_menuime >= 14:
            day1txt = _('Tonight:')
            day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
        os.system('dcop kxdocker docker addIcon Current %s "%s : %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_curr', situtext.encode(encoding), weather.temperature()))
        os.system('dcop kxdocker docker changeEncodedTextByName Current "%s" %s' %(situtext.encode(encoding) + ' : ' + weather.temperature(),encoding))
        os.system('dcop kxdocker docker addIcon For1 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_0', day1txt.encode(encoding), day1tmp))
        os.system('dcop kxdocker docker changeEncodedTextByName For1 "%s" %s' %(day1txt.encode(encoding) + ' ' + day1tmp,encoding))
        os.system('dcop kxdocker docker addIcon For2 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_1', _(weather.get_forecast(1).weekday()).encode(encoding) + ":", weather.get_forecast(1).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For2 "%s" %s' %(_(weather.get_forecast(1).weekday()).encode(encoding) + ":" + weather.get_forecast(1).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For3 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_2', _(weather.get_forecast(2).weekday()).encode('utf-8') + ":", weather.get_forecast(2).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For3 "%s" %s' %(_(weather.get_forecast(2).weekday()).encode(encoding) + ":" + weather.get_forecast(2).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For4 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_3', _(weather.get_forecast(3).weekday()).encode('utf-8') + ":", weather.get_forecast(3).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For4 "%s" %s' %(_(weather.get_forecast(3).weekday()).encode(encoding) + ":" + weather.get_forecast(3).temp_range(),encoding))
        os.system('dcop kxdocker docker addIcon For5 %s "%s %s" /dev/null GIcon lwp none none none none' %(config_directory + '/kxdico_4', _(weather.get_forecast(4).weekday()).encode('utf-8') + ":", weather.get_forecast(4).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For5 "%s" %s' %(_(weather.get_forecast(4).weekday()).encode(encoding) + ":" + weather.get_forecast(4).temp_range(),encoding))

class changeKxdocker(Thread):
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        sep = weather.get_forecast(0).temp_range().find('/')
        os.system('dcop kxdocker docker changeImageByName Current %s' %(config_directory + '/kxdico_curr'))
        os.system('dcop kxdocker docker changeImageByName For1 %s' %(config_directory + '/kxdico_0'))
        os.system('dcop kxdocker docker changeImageByName For2 %s' %(config_directory + '/kxdico_1'))
        os.system('dcop kxdocker docker changeImageByName For3 %s' %(config_directory + '/kxdico_2'))
        os.system('dcop kxdocker docker changeImageByName For4 %s' %(config_directory + '/kxdico_3'))
        os.system('dcop kxdocker docker changeImageByName For5 %s' %(config_directory + '/kxdico_4'))
        day1txt = _('Today:')
        day1tmp = weather.get_forecast(0).temp_range()
        if base_menuime >= 14:
            day1txt = _('Tonight:')
            day1tmp = "Lo:" + weather.get_forecast(0).temp_range()[:sep]
        os.system('dcop kxdocker docker changeTextByName Current "%s : %s"' %(situtext.encode(encoding), weather.temperature()))
        os.system('dcop kxdocker docker changeEncodedTextByName Current "%s" %s' %(situtext.encode(encoding) + ": " + weather.temperature(),encoding))
        os.system('dcop kxdocker docker changeTextByName For1 "%s %s"' %(day1txt, day1tmp))
        os.system('dcop kxdocker docker changeEncodedTextByName For1 "%s" %s' %(day1txt.encode(encoding) + " " + day1tmp,encoding))
        os.system('dcop kxdocker docker changeTextByName For2 "%s %s"' %(_(weather.get_forecast(1).weekday()).encode(encoding) + ":", weather.get_forecast(1).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For2 "%s" %s' %(_(weather.get_forecast(1).weekday()).encode(encoding) + ":" + weather.get_forecast(1).temp_range(),encoding))
        os.system('dcop kxdocker docker changeTextByName For3 "%s %s"' %(_(weather.get_forecast(2).weekday()).encode(encoding) + ":", weather.get_forecast(2).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For3 "%s" %s' %(_(weather.get_forecast(2).weekday()).encode(encoding) + ":" + weather.get_forecast(2).temp_range(),encoding))
        os.system('dcop kxdocker docker changeTextByName For4 "%s %s"' %(_(weather.get_forecast(3).weekday()).encode(encoding) + ":", weather.get_forecast(3).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For4 "%s" %s' %(_(weather.get_forecast(3).weekday()).encode(encoding) + ":" + weather.get_forecast(3).temp_range(),encoding))
        os.system('dcop kxdocker docker changeTextByName For5 "%s %s"' %(_(weather.get_forecast(4).weekday()).encode(encoding) + ":", weather.get_forecast(4).temp_range()))
        os.system('dcop kxdocker docker changeEncodedTextByName For5 "%s" %s' %(_(weather.get_forecast(4).weekday()).encode(encoding) + ":" + weather.get_forecast(4).temp_range(),encoding))

class fadeMoon(Thread):
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        for i in range(len(theme_path)):
            theme_path[i] = theme_path[i].replace('\n','')
        if theme_path[1] == '0':
            moon_tmpf = open(theme_path[0] + 'moon_icons/' + moon_icon,'r')
            moon_data = moon_tmpf.read()
        else:
            zip_file = zipfile.ZipFile(theme_path[0])
            moon_data = zip_file.read('moon_icons/' + moon_icon)
        moon_file = open(config_directory + '/fade/moon.png', 'w')
        print >> moon_file, moon_data
        moon_file.close()
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/fade/moon.png', alpha, config_directory + '/fade/moon_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1
        if (iconset == 'Liquid') or (iconset == 'Umicons'):
            if theme_path[1] == '0':
                main_tmpf = open(karamba.getThemePath(self.widget) + '/' + iconsetpath + weather.icon_path(),'r')
                main_data = main_tmpf.read()
            else:
                zip_file = zipfile.ZipFile(theme_path[0])
                main_data = zip_file.read(iconsetpath + weather.icon_path())
        else:
            main_tmpf = open(alticonsetpath + '/' + iconset + '/' + weather.icon_path(),'r')
            main_data = main_tmpf.read()
        main_file = open(config_directory + '/fade/main.png', 'w')
        print >> main_file, main_data
        main_file.close()
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/fade/main.png', alpha, config_directory + '/fade/main_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1

class fadeBG(Thread):
    def __init__ (self,widget):
        Thread.__init__(self)
        self.widget = widget
    def run(self):
        bg_file_orig = open(config_directory + '/background/ddc_bg.png','r')
        bg_data = bg_file_orig.read()
        bg_file = open(config_directory + '/fade/ddcbg.png', 'w')
        print >> bg_file, bg_data
        bg_file.close()
        bg_file_orig = open(config_directory + '/background/dd_bg.png','r')
        bg_data = bg_file_orig.read()
        bg_file = open(config_directory + '/fade/ddbg.png', 'w')
        print >> bg_file, bg_data
        bg_file.close()
        bg_file_orig = open(config_directory + '/background/hbg.png','r')
        bg_data = bg_file_orig.read()
        bg_file = open(config_directory + '/fade/hbg.png', 'w')
        print >> bg_file, bg_data
        bg_file.close()
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/fade/ddcbg.png', alpha, config_directory + '/fade/ddcbg_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/fade/ddbg.png', alpha, config_directory + '/fade/ddbg_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/fade/hbg.png', alpha, config_directory + '/fade/hbg_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1

def createSkyConditionPot(widget):

    a = [_('Rain / snow showers / wind'),
        _('Thunder in the vicinity'),
        _('Rain / wind'),
        _('Haze'),
        _('Pm light rain'),
        _('Smoke'),
        _('Clear and windy'),
        _('Fog and windy'),
        _('Cloudy and windy'),
        _('Flurries'),
        _('Pm showers'),
        _('Heavy snow'),
        _('Strong storms'),
        _('Scattered-storms'),
        _('Sleet showers'),
        _('Rain'),
        _('Light wintry mix'),
        _('Partly cloudy / wind'),
        _('Isolated t-storms'),
        _('Heavy Snow and Windy'),
        _('Snow and windy'),
        _('Mostly sunny / wind'),
        _('Light snow grains and fog'),
        _('Wintry mix to snow'),
        _('Misty'),
        _('Light snow and sleet'),
        _('Drifting snow'),
        _('Mist and light rain'),
        _('Rain / snow showers'),
        _('Light freezing rain'),
        _('Pm t-showers'),
        _('Partly cloudy'),
        _('Heavy rain shower'),
        _('Scattered t-storms'),
        _('Heavy rain / wind'),
        _('Heavy snow / wind'),
        _('Pm light snow'),
        _('Mostly sunny'),
        _('Heavy rain and windy'),
        _('Few snow showers'),
        _('Am snow showers'),
        _('Snow and sleet'),
        _('Light rain and windy'),
        _('Fog'),
        _('Light rain with thunder'),
        _('Light rain and fog'),
        _('Sunny and Windy'),
        _('PM t-storms'),
        _('Pm t-storms'),
        _('Blowing dusty and windy'),
        _('Scattered storms'),
        _('Mostly cloudy'),
        _('Light rain shower'),
        _('Isolated T-storms / wind'),
        _('Am snow'),
        _('Blowing snow'),
        _('Scattered flurries'),
        _('Snow / wind'),
        _('Snow grains'),
        _('Freezing rain and sleet'),
        _('rising'),
        _('T-showers'),
        _('AM t-storms / wind'),
        _('Light snow'),
        _('Light rain with Thunder'),
        _('Mostly cloudy / wind'),
        _('Light rain'),
        _('Cloudy'),
        _('Rain / snow / wind'),
        _('Pm rain / snow showers'),
        _('Pm rain'),
        _('Thunder and windy'),
        _('Blowing snow and windy'),
        _('Light snow shower'),
        _('Mist'),
        _('Fair'),
        _('Light rain shower and windy'),
        _('Am light rain'),
        _('T-storm'),
        _('Snow and fog'),
        _('Scattered snow showers / wind'),
        _('Clear / wind'),
        _('Pm snow showers'),
        _('Am rain / snow showers'),
        _('Am showers'),
        _('Rain and windy'),
        _('Snow'),
        _('Snow shower / wind'),
        _('Rain / snow'),
        _('Wintry mix'),
        _('Scattered t-storms'),
        _('Mostly clear'),
        _('Light Freezing Rain'),
        _('Light snow shower and windy'),
        _('Rain to snow'),
        _('Freezing Rain'),
        _('Ice Crystals'),
        _('Showers / wind'),
        _('Sunny'),
        _('Thunder'),
        _('Variable'),
        _('Foggy'),
        _('Light freezing drizzle'),
        _('Freezing drizzle'),
        _('Rain / freezing rain'),
        _('Pm snow showers / wind'),
        _('Few showers'),
        _('steady'),
        _('N/A'),
        _('Sunny / wind'),
        _('Light snow and windy'),
        _('Snow and thunder and fog'),
        _('Flurries / wind'),
        _('Heavy showers'),
        _('Few showers / wind'),
        _('Light snow grains'),
        _('Partly cloudy and windy'),
        _('N/a'),
        _('Am rain / snow'),
        _('Pm snow'),
        _('Am rain'),
        _('Heavy t-storm'),
        _('Light snow showers'),
        _('Fair and windy'),
        _('Showers'),
        _('Scattered strong storms'),
        _('Am clouds / pm sun'),
        _('Light drizzle and windy'),
        _('Mostly cloudy and windy'),
        _('Drizzle'),
        _('Unlimited'),
        _('Light freezing rain and fog'),
        _('Sprinkles'),
        _('Showers in the vicinity'),
        _('Sunny intervals'),
        _('Light showers'),
        _('Light snow and fog'),
        _('Thundery showers'),
        _('falling'),
        _('Light drizzle'),
        _('Scattered t-storms / wind'),
        _('Rain shower and windy'),
        _('Heavy rain'),
        _('Light rain / wind'),
        _('Rain / thunder'),
        _('Snow shower'),
        _('T-storms'),
        _('Scattered showers'),
        _('Clear'),
        _('Rain and snow'),
        _('Heavy snow showers'),
        _('Heavy snow shower'),
        _('Light freezing rain and windy'),
        _('Rain/thunder'),
        _('Patches of fog'),
        _('Rain shower'),
        _('Light rain and freezing rain'),
        _('Rain and freezing rain'),
        _('Sleet'),
        _('Light rain / freezing rain'),
        _('Shallow fog'),
        _('Cloudy / wind'),
        _('Scattered snow showers'),
        _('T-storm and windy'),
        _('Mon'),
        _('Tue'),
        _('Wed'),
        _('Thu'),
        _('Fri'),
        _('Sat'),
        _('Sun'),
        _('2day'),
        _('2nite'),
        _('New Moon'),
        _('Waxing Crescent'),
        _('First Quarter'),
        _('Waxing Gibbous'),
        _('Full Moon'),
        _('Waning Gibbous'),
        _('Last Quarter'),
        _('Waning Crescent')]
        
def initTranslation(widget, lang):
    import re
    global _, encoding, language
    if(lang == ''):
          _ = lambda(x): x
    else:
        language = lang
        mo = 'locale/%s/LC_MESSAGES/%s.mo' % (language, __name__)
        s = karamba.readThemeFile(widget, mo)
        fp = StringIO(s)
        gt = GNUTranslations(fp)
        enc = gt.info()
        encoding = string.lower(enc.get('content-type').replace('text/plain; charset=',''))
        _ = gt.ugettext
    

# Basic function to reduce amount of typing necessary to draw text
def prettyText(widget, size, font, shadowflag, textname):
    global dropdownflag
    karamba.changeTextSize(widget, textname, size)
    karamba.changeTextFont(widget, textname, font)
    karamba.changeTextShadow(widget, textname, shadowflag)
    if dropdownflag == 0:
        karamba.changeTextColor(widget, textname, red, green, blue)
    else:
        karamba.changeTextColor(widget, textname, reddrop, greendrop, bluedrop)
    #karamba.changeText(widget, textname, karamba.getTextValue(widget, textname).decode("utf-8"))
    #karamba.redrawWidget(widget)
# A set of functions to display data/images on roll-down panels

def expandEngine(widget, icon, animbg, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, xFinal, yFinal, hFinal, wFinal, degStart, degInc, mapFlag):
    global animpanel
    karamba.changeImageIntensity(widget, icon, 0.3, 0)
    if (animate == 0) and (mapFlag == 0):
        for i in range(10):
            karamba.resizeImage(widget, icon, karamba.getImageHeight(widget, icon) - 1, karamba.getImageWidth(widget, icon) -1)
            karamba.redrawWidget(widget)
        karamba.resizeImage(widget, icon, wIcon, hIcon)
        karamba.redrawWidget(widget)
    animpanel = karamba.createImage(widget, xPanel, yPanel, animbg)
    for i in range(10):
        karamba.resizeImage(widget, animpanel, wPanel, hPanel)
            
        if mapFlag == 1:
            if yIcon > 12:
                yIcon = yIcon - 2
                karamba.moveImage(widget, icon, xIcon, yIcon)
        karamba.moveImage(widget, animpanel, xPanel, yPanel)
        xPanel = xPanel - xPanelInc
        yPanel = yPanel - yPanelInc
        hPanel = hPanel + hPanelInc
        wPanel = wPanel + wPanelInc
        if i != 0:
            karamba.redrawWidget(widget)
        #x = x - 8
        #y = y - 8
    karamba.moveImage(widget, animpanel, xFinal, yFinal)
    karamba.resizeImage(widget, animpanel, hFinal, wFinal)
    karamba.redrawWidget(widget)
    
def contractEngine(widget, icon, panel, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, degStart, degInc, mapFlag):

    deg = -36
    for i in range(10):
##        if (animate == 0) and (mapFlag == 0):
##            #karamba.resizeImage(widget, mainpic, x, y)
##            karamba.rotateImage(widget, icon, degStart)
##            w = karamba.getImageWidth(widget, icon)
##            h = karamba.getImageHeight(widget, icon)
##            karamba.moveImage(widget, icon, xIcon-((w-wIcon)/2),yIcon-((h-hIcon)/2))
##            degStart = degStart - degInc
        if mapFlag == 1:
            if yIcon < 35:
                yIcon = yIcon + 2
                karamba.moveImage(widget, icon, xIcon, yIcon)
        xPanel = xPanel + xPanelInc
        yPanel = yPanel + yPanelInc
        hPanel = hPanel - hPanelInc
        wPanel = wPanel - wPanelInc
        karamba.moveImage(widget, panel, xPanel, yPanel)
        karamba.resizeImage(widget, panel, wPanel, hPanel)
        if i != 9:
            karamba.redrawWidget(widget)
    karamba.deleteImage(widget, panel)
    karamba.removeImageEffects(widget, icon)
    karamba.redrawWidget(widget)

def dropDownEngine(widget, icon, animbg, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc, hFinal, wFinal, degStart, degInc, xPanel, yPanel, mapFlag):
    global animpanel
    karamba.changeImageIntensity(widget, icon, 0.3, 0)
    if (animate == 0) and (mapFlag == 0):
        for i in range(10):
            karamba.resizeImage(widget, icon, karamba.getImageHeight(widget, icon) - 1, karamba.getImageWidth(widget, icon) -1)
            karamba.redrawWidget(widget)
        karamba.resizeImage(widget, icon, wIcon, hIcon)
        karamba.redrawWidget(widget)
    animpanel = karamba.createImage(widget, xPanel, yPanel, animbg)
    karamba.moveImage(widget, animpanel, xPanel, yPanel)
    karamba.resizeImage(widget, animpanel, wStart, hStart)

    karamba.redrawWidget(widget)
    #x = 108
    #y = 108
    deg = 36
    for i in range(rangeStart,rangeEnd,rangeInc):
        karamba.resizeImage(widget, animpanel, wStart, i)
        if mapFlag == 1:
            if yIcon > 12:
                yIcon = yIcon - 2
                karamba.moveImage(widget, icon, xIcon, yIcon)
        karamba.redrawWidget(widget)
        #x = x - 8
        #y = y - 8
    karamba.resizeImage(widget, animpanel, wFinal, hFinal)
    karamba.redrawWidget(widget)

def rollUpEngine(widget, icon, animbg, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc, degStart, degInc, mapFlag):
    deg = -36
    for i in range(rangeStart, rangeEnd, rangeInc):
        karamba.resizeImage(widget, animpanel, wStart, i)
        if mapFlag == 1:
            if yIcon < 35:
                yIcon = yIcon + 2
                karamba.moveImage(widget, icon, xIcon, yIcon)
        karamba.redrawWidget(widget)
        #x = x + 8
        #y = y + 8
    karamba.deleteImage(widget, animpanel)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
    karamba.removeImageEffects(widget, icon)
    karamba.redrawWidget(widget)

def fadeInEngine(widget, icon, animbg, hIcon, wIcon, prefix, xPanel, yPanel, wFinal, hFinal, mapFlag, yIcon, xIcon):
    global animpanel
    karamba.changeImageIntensity(widget, icon, 0.3, 0)
    karamba.changeImageIntensity(widget, icon, 0.3, 0)
    if (animate == 0) and (mapFlag == 0):
        for i in range(10):
            karamba.resizeImage(widget, icon, karamba.getImageHeight(widget, icon) - 1, karamba.getImageWidth(widget, icon) -1)
            karamba.redrawWidget(widget)
        karamba.resizeImage(widget, icon, wIcon, hIcon)
        karamba.redrawWidget(widget)    
    
    for i in range(10):
        animpanel = karamba.createImage(widget, xPanel, yPanel, config_directory + '/fade/' + prefix + str(i) + '.png')
        karamba.resizeImage(widget, animpanel, wFinal, hFinal)
        if mapFlag == 1:
            if yIcon > 12:
                yIcon = yIcon - 2
                karamba.moveImage(widget, icon, xIcon, yIcon)

        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, animpanel)
        time.sleep(0.02)
    animpanel = karamba.createImage(widget, xPanel, yPanel, animbg)

    karamba.resizeImage(widget, animpanel, wFinal, hFinal)
    karamba.redrawWidget(widget)

def fadeOutEngine(widget, icon, animbg, prefix, xPanel, yPanel, wFinal, hFinal, mapFlag, yIcon, xIcon):
    global animpanel
    karamba.deleteImage(widget, animpanel)
    for i in range(9,0,-1):
        animpanel = karamba.createImage(widget, xPanel, yPanel, config_directory + '/fade/' + prefix + str(i) + '.png')
        karamba.resizeImage(widget, animpanel, wFinal, hFinal)
        if mapFlag == 1:
            if yIcon < 35:
                yIcon = yIcon + 2
                karamba.moveImage(widget, icon, xIcon, yIcon)
        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, animpanel)
        time.sleep(0.04)
        #x = x + 8
        #y = y + 8
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
    karamba.removeImageEffects(widget, icon)
    karamba.redrawWidget(widget)

def showSatPic(widget):
    global satpic, satpicon, webbypicbg, animpanel
    webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
    karamba.resizeImage(widget, webbypicbg, 1, 1)
    karamba.redrawWidget(widget)
    #widget, icon, panel, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, xFinal, yFinal, hFinal, wFinal, degStart, degInc, mapFlag
    if animstyle == 1:
        expandEngine(widget, satbutt, satfile, 0, 0, 179, 35, 0, 0, 130, 104, 10, 7, 14, 19, 35, 34, 190, 140, 0, 0, 1)

#widget, icon, panel, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc, hFinal, wFinal, degStart, degInc
    elif animstyle == 0:
        dropDownEngine(widget, satbutt, satfile, 20, 190, 0, 0, 179, 35, 20, 140, 10, 140, 190, 0, 0, 35, 34, 1)
    elif animstyle == 2:
        fadeInEngine(widget, satbutt, satfile, 0, 0, "sat_alpha_", 35, 34, 190, 140, 1, 35, 179)
    else:
        yIcon = karamba.getImagePos(widget,satbutt)[1]
        xIcon = karamba.getImagePos(widget,satbutt)[0]
        for i in range(20):
            if yIcon > 12:
                yIcon = yIcon - 2
                karamba.moveImage(widget, satbutt, xIcon, yIcon)
            karamba.redrawWidget(widget)

        animpanel = karamba.createImage(widget,35,34,satfile)
        karamba.resizeImage(widget,animpanel,190,140)

#     karamba.resizeImage(widget, satpic, 190, 20)
#     karamba.redrawWidget(widget)
#     xpos = 179
#     ypos = 35
#     for i in range(20,140,10):
#         karamba.resizeImage(widget, satpic, 190, i)
#         if ypos > 12:
#             ypos = ypos - 2
#             karamba.moveImage(widget, satbutt, xpos, ypos)
#         karamba.redrawWidget(widget)
#     karamba.resizeImage(widget, satpic, 190, 140)
    karamba.resizeImage(widget, webbypicbg, 216, 166)
    karamba.redrawWidget(widget)
    satpicon = 1

def removeSatPic(widget):
    global satpicon
    karamba.deleteImage(widget, webbypicbg)
    #widget, icon, panel, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, degStart, degInc, mapFlag
    if animstyle == 1:
        contractEngine(widget, satbutt, animpanel, 0, 0, 179, 15, 140, 190, 35, 34, 10, 7, 14, 19, 0, 0, 1)
    #widget, icon, panel, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc, degStart, degInc, mapFlag
    elif animstyle == 0:
        rollUpEngine(widget, satbutt, animpanel, 0, 190, 0, 0, 179, 15, 140, 20, -10, 0, 0, 1)
        
    elif animstyle == 2:
        fadeOutEngine(widget, satbutt, animpanel, "sat_alpha_", 35, 34, 190, 140, 1, 15, 179)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)
        yIcon = karamba.getImagePos(widget,satbutt)[1]
        xIcon = karamba.getImagePos(widget,satbutt)[0]
        for i in range(20):
            if yIcon < 36:
                yIcon = yIcon + 2
                karamba.moveImage(widget, satbutt, xIcon, yIcon)
            karamba.redrawWidget(widget)
        karamba.moveImage(widget,satbutt,xIcon,35)
        karamba.redrawWidget(widget)

#     xpos = 179
#     ypos = 12
#     for i in range(140,20,-10):
#         karamba.resizeImage(widget, satpic, 190, i)
#         if ypos < 35:
#             ypos = ypos + 2
#             karamba.moveImage(widget, satbutt, xpos, ypos)
#         karamba.redrawWidget(widget)
#     karamba.moveImage(widget, satbutt, 179, 36)
#     karamba.deleteImage(widget, satpic)
#     karamba.redrawWidget(widget)
    satpicon = 0

def showEq(widget, region):
    if karamba.getThemePath(widget)[-3:] == 'skz':
        skz_file = zipfile.ZipFile(karamba.getThemePath(widget), 'r')
        earthq_file = skz_file.read('earthquake/' + map_matrix[0][region])
        try:
            os.mknod(config_directory +'/lwp_eq')
        except(OSError):
            pass
        eq_file = open(config_directory + '/lwp_eq','w')
        eq_file.write(earthq_file)
        eq_file.close()
        earthquake_file = (config_directory + '/lwp_eq')
    else:
        earthquake_file = karamba.getThemePath(widget) + 'earthquake/' + map_matrix[0][region]
    os.system('konqueror --geometry %s %s &' %(eq_win[region], earthquake_file))


def showWebcamPic(widget):
    global webbypic, webpicon, webbypicbg, animpanel
    webbypicbg = karamba.createImage(widget, 23, 25, 'webcambg.png')
    karamba.resizeImage(widget, webbypicbg, 1, 1)
    if animstyle == 1:
        expandEngine(widget, cambutt, filename, 0, 0, 203, 35, 0, 0, 130, 104, 10, 7, 14, 19, 35, 34, 190, 140, 0, 0, 1)
    elif animstyle == 0:
        dropDownEngine(widget, cambutt, filename, 20, 190, 0, 0, 203, 35, 20, 140, 10, 140, 190, 0, 0, 35, 34, 1)
    elif animstyle == 2:
        fadeInEngine(widget, cambutt, filename, 0, 0, "web_alpha_", 35, 34, 190, 140, 1, 35, 203)
    else:
        yIcon = karamba.getImagePos(widget,cambutt)[1]
        xIcon = karamba.getImagePos(widget,cambutt)[0]
        for i in range(20):
            if yIcon > 12:
                yIcon = yIcon - 2
                karamba.moveImage(widget, cambutt, xIcon, yIcon)
            karamba.redrawWidget(widget)
        animpanel = karamba.createImage(widget,35,34,filename)
        karamba.resizeImage(widget,animpanel,190,140)

    karamba.resizeImage(widget, webbypicbg, 216, 166)
    karamba.redrawWidget(widget)
    webpicon = 1

def removeWebcamPic(widget):
    global webpicon
    karamba.deleteImage(widget, webbypicbg)
    if animstyle == 1:
        contractEngine(widget, cambutt, animpanel, 0, 0, 203, 15, 140, 190, 35, 34, 10, 7, 14, 19, 0, 0, 1)
    elif animstyle == 0:
        rollUpEngine(widget, cambutt, animpanel, 0, 190, 0, 0, 203, 12, 140, 20, -10, 0, 0, 1)
    elif animstyle == 2:
        fadeOutEngine(widget, cambutt, animpanel, "web_alpha_", 35, 34, 190, 140, 1, 15, 203)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)
        yIcon = karamba.getImagePos(widget,satbutt)[1]
        xIcon = karamba.getImagePos(widget,satbutt)[0]
        for i in range(20):
            if yIcon < 36:
                yIcon = yIcon + 2
                karamba.moveImage(widget, cambutt, xIcon, yIcon)
            karamba.redrawWidget(widget)
        karamba.moveImage(widget,satbutt,xIcon,35)
        karamba.redrawWidget(widget)
    webpicon = 0

def createBBCDayDetail(widget, day):
    global weather, order, separator, ddbg, ddmainpic, setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress, ddday, ddtemp, ddwind, ddcwstr, ddsitu, ddon, ddsunrise, ddsunset, ddhumi, ddvisi, ddpress, daypicrem, topBar, daypicpos, animate, dropdownflag, slideTextGrp, slideYPos, animpanel
    situtext = _(weather.get_forecast(day).sky())
    dropdownflag = 1
    if situtext == None:
        situtext = weather.get_forecast(day).sky()
        transError(widget, weather.get_forecast(day).sky())
    #if altback == 1:
        #ddbg = "background/dd_bg9.png"
    #elif altback == 2:
        #ddbg = "background/dd_bg17.png"
    #elif altback == 3:
        #ddbg = "background/dd_bg21.png"
    #elif altback == 4:
        #ddbg = "background/dd_bg20.png"
    #elif altback == 5:
        #ddbg = "background/dd_bg17.png"
    #elif altback == 6:
        #ddbg = "background/dd_bg23.png"
    #elif altback == 7:
        #ddbg = "background/dd_bg24.png"
    #elif altback == 8:
        #ddbg = "background/dd_bg25.png"
    #elif flatflag == 1:
        #ddbg = "background/dd_bgflat.png"
    #else:
        #ddbg = "background/dd_bg.png"
    if animstyle == 1:
        expandEngine(widget, daypicrem[day], ddbg, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), daypicpos[day], 140, 0, 0, 120, 89, 10, 7, 14, 22, 26, 25, 210, 130, 90, 30, 0)
    # widget, icon, panel, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc
    elif animstyle == 0:
        dropDownEngine(widget, daypicrem[day], ddbg, 20, 210, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), daypicpos[day], 140, 20, 140, 10, 140, 210, 30, 30, 26, 25, 0)
        
    elif animstyle == 2:
        fadeInEngine(widget, daypicrem[day], ddbg, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), "ddbg_alpha_", 26, 25, 210, 140, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,26,25,ddbg)
    karamba.redrawWidget(widget)

    ddmainpic = karamba.createImage(widget, 135, 35, iconsetpath + weather.get_forecast(day).large_icon_path())
    karamba.hideImage(widget, ddmainpic)
    if textstyle == 0:
        xpos = 50
    else:
        xpos = 255
    setday = karamba.createText(widget, xpos, 33, 150, 20, _('Detail For:') + '  ' +  weather.get_forecast(day).weekday())
    prettyText(widget, fontSizeMatrix[3], fontFamilyMatrix[3], shadow, setday)
    titletext = [setday]
    emergeText(widget, titletext, 1, 12, 0)
    settemp = karamba.createText(widget, xpos, 52, 70, 20, _('Temp:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, settemp)
    setwind = karamba.createText(widget, xpos, 64, 70, 20, _('Wind:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setwind)
    setsitu = karamba.createText(widget, xpos, 76, 70, 20, _('Sky:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setsitu)
    setsun = karamba.createText(widget, xpos, 88, 70, 20, _('Sun:'))
    prettyText(widget, fontSizeMatrix[2],fontFamilyMatrix[2] , shadow, setsun)
    sethumi = karamba.createText(widget, xpos, 100, 70, 20, _('Humi:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, sethumi)
    setvisi = karamba.createText(widget, xpos, 112, 70, 20, _('Visi:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setvisi)
    setpress = karamba.createText(widget, xpos, 124, 70, 20, _('Pres:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setpress)
    slideTextGrp = [setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress]
    slideYPos = [33, 52, 64, 76, 88, 100, 112, 124]
    if textstyle == 0:
        slideTextGrp = [settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress]
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, xpos, slideTextGrp, slideYPos, 50)

    if textstyle == 0:
        xpos = 100
    else:
        xpos = 255
    ddtemp = karamba.createText(widget, xpos, 52, 130, 20, weather.get_forecast(day).temperature_range(order, separator))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddtemp)
    ddwind = karamba.createText(widget, xpos, 64, 130, 20, weather.get_forecast(day).wind() + ' ' + weather.get_forecast(day).wind_speed())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddwind)
    ddsitu = karamba.createText(widget, xpos, 76, 130, 20, situtext)
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddsitu)
    ddsunrise = karamba.createText(widget, xpos, 88, 130, 20, weather.get_forecast(day).sunrise() + ' ' + weather.get_forecast(day).sunset())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddsunrise)
    ddhumi = karamba.createText(widget, xpos, 100, 130, 20, weather.get_forecast(day).humidity())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddhumi)
    ddvisi = karamba.createText(widget, xpos, 112, 130, 20, weather.get_forecast(day).visibility())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddvisi)
    ddpress = karamba.createText(widget, xpos, 124, 130, 20, weather.get_forecast(day).pressure())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddpress)
    slideTextGrp = [ddtemp, ddwind, ddsitu, ddsunrise, ddhumi, ddvisi, ddpress]
    slideYPos = [52, 64, 76, 88, 100, 112, 124]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 100)
    karamba.showImage(widget, ddmainpic)
    panelicon = [ddmainpic]
    emergeIcon(widget, panelicon, 1, karamba.getImageWidth(widget,ddmainpic), karamba.getImageHeight(widget,ddmainpic), 0)
    ddon = 1
    dropdownflag = 0


def deleteBBCDayDetail(widget, day):
    global ddon, ddbg, ddmainpic, setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress, ddday, ddtemp, ddwind, ddcwstr, ddsitu, ddsunrise, ddsunset, ddhumi, ddvisi, ddpress, daypicrem, topBar, daypicpos, animate, otherdetail
    slideTextGrp = [setday, settemp, setwind, setsitu, setsun, sethumi, setvisi, setpress]
    slideYPos = [33, 52, 64, 76, 88, 100, 112, 124]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 50, slideTextGrp, slideYPos, -150)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)    
    slideTextGrp = [ddtemp, ddwind, ddsitu, ddsunrise, ddhumi, ddvisi, ddpress]
    slideYPos = [52, 64, 76, 88, 100, 112, 124]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 100, slideTextGrp, slideYPos, -150)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    if textstyle != 0:
        slideIconGrp = [ddmainpic]
        slideYPos = [35]
        slideIcons(widget, 135, slideIconGrp, slideYPos, -150)
    emergeIcon(widget, [ddmainpic], 110, 1, 1, 1)
    karamba.deleteImage(widget,ddmainpic)
    karamba.redrawWidget(widget)
    if animstyle == 1:
        contractEngine(widget, daypicrem[day], animpanel, 28, 28, daypicpos[day], 140, 140, 210, 25, 26, 11, 7, 14, 21, 0, 30, 0)
    elif animstyle == 0:
        rollUpEngine(widget, daypicrem[day], animpanel, 140, 210, 28, 28, daypicpos[day], 140, 130, 10, -10, 330, 30, 0)
    elif animstyle == 2:
        fadeOutEngine(widget, mainpic, animpanel, "ddbg_alpha_", 26, 25, 210, 140, 0, 0, 0)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)

    ddon = 0
    otherdetail = 1

def createWcomDayDetail(widget, day):
    global weather, order, separator, ddbg, setday, settemp, setrain, setsitu, ddday, ddtemp, ddrain, ddsitu, ddon, setdate, dddate, daypicrem, topBar, daypicpos, animate, ddmainpic, dropdownflag, slideTextGrp, slideYPos,animpanel
    situtext = _(weather.get_forecast(day).sky())
    dropdownflag = 1
    if situtext == None:
        situtext = weather.get_forecast(day).sky()
        transError(widget, weather.get_forecast(day).sky())
    #if altback == 1:
        #ddbg = "background/dd_bg9.png"
    #elif altback == 2:
        #ddbg = "background/dd_bg17.png"
    #elif altback == 3:
        #ddbg = "background/dd_bg21.png"
    #elif altback == 4:
        #ddbg = "background/dd_bg20.png"
    #elif altback == 5:
        #ddbg = "background/dd_bg17.png"
    #elif altback == 6:
        #ddbg = "background/dd_bg23.png"
    #elif altback == 7:
        #ddbg = "background/dd_bg24.png"
    #elif altback == 8:
        #ddbg = "background/dd_bg25.png"
    #elif flatflag == 1:
        #ddbg = "background/dd_bgflat.png"
    #else:
        #ddbg = "background/dd_bg.png"
    if animstyle == 0:
        dropDownEngine(widget, daypicrem[day], ddbg, 20, 210, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), daypicpos[day], 140, 20, 140, 10, 140, 210, 30, 30, 26, 25, 0)
    elif animstyle == 1:
        expandEngine(widget, daypicrem[day], ddbg, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), daypicpos[day], 140, 0, 0, 120, 89, 10, 7, 14, 22, 26, 25, 210, 130, 90, 30, 0) 
    elif animstyle == 2:
        fadeInEngine(widget, daypicrem[day], ddbg, karamba.getImageHeight(widget, daypicrem[day]), karamba.getImageWidth(widget, daypicrem[day]), "ddbg_alpha_", 26, 25, 210, 140, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,26,25,ddbg)
    karamba.redrawWidget(widget)
    ddmainpic = karamba.createImage(widget, 135, 35, iconsetpath + weather.get_forecast(day).large_icon_path())
    karamba.hideImage(widget, ddmainpic)
    if textstyle == 0:
        xpos = 50
    else:
        xpos = 255
    setday = karamba.createText(widget, xpos, 33, 120, 20, _('Detail For:') + '  ' + weather.get_forecast(day).weekday())
    prettyText(widget, fontSizeMatrix[3], fontFamilyMatrix[3], shadow, setday)
    if textstyle == 0:
        slideTextGrp = [setday]
        emergeText(widget, slideTextGrp, 1, 12, 0)
    setdate = karamba.createText(widget, xpos, 60, 70, 20, _('Date:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setdate)
    settemp = karamba.createText(widget, xpos, 80, 70, 20, _('Temp:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, settemp)
    setrain = karamba.createText(widget, xpos, 100, 70, 20, _('Rain:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setrain)
    setsitu = karamba.createText(widget, xpos, 120, 70, 20, _('Sky:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setsitu)
    slideTextGrp = [setday, setdate, settemp, setrain, setsitu]
    slideYPos = [33, 60, 80, 100, 120]
    if textstyle == 0:
        slideTextGrp = [setdate, settemp, setrain, setsitu]
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, xpos, slideTextGrp, slideYPos, 50)

    if textstyle == 0:
        xpos = 100
    else:
        xpos = 255
    dddate = karamba.createText(widget, xpos, 60, 50, 20, weather.get_forecast(day).date())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, dddate)
    ddtemp = karamba.createText(widget, xpos, 80, 130, 20, weather.get_forecast(day).temperature_range(order, separator))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddtemp)
    ddrain = karamba.createText(widget, xpos, 100, 50, 20, weather.get_forecast(day).rain())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddrain)
    ddsitu = karamba.createText(widget, xpos, 120, 110, 20, situtext)
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddsitu)
    
    slideTextGrp = [dddate, ddtemp, ddrain, ddsitu]
    slideYPos = [60, 80, 100, 120]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 100)
    karamba.showImage(widget, ddmainpic)
    panelicon = [ddmainpic]
    emergeIcon(widget, panelicon, 1, karamba.getImageWidth(widget,ddmainpic), karamba.getImageHeight(widget,ddmainpic), 0)
    ddon = 1
    dropdownflag = 0


def deleteWcomDayDetail(widget, day):
    global ddon, ddbg, setday, settemp, setrain, setsitu, ddday, ddtemp, ddrain, ddsitu, dddate, setdate, daypicrem, topBar, daypicpos, animate, otherdetail
    slideTextGrp = [setday, setdate, settemp, setrain, setsitu]
    slideYPos = [33, 60, 80, 100, 120]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 50, slideTextGrp, slideYPos, -150)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    slideTextGrp = [dddate, ddtemp, ddrain, ddsitu]
    slideYPos = [60, 80, 100, 120]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 100, slideTextGrp, slideYPos, -150)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    if textstyle != 0:
        slideIconGrp = [ddmainpic]
        slideYPos = [35]
        slideIcons(widget, 135, slideIconGrp, slideYPos, -150)
    emergeIcon(widget, [ddmainpic], 110, 1, 1, 1)
    karamba.deleteImage(widget,ddmainpic)
    karamba.redrawWidget(widget)
    if animstyle == 0:
        rollUpEngine(widget, daypicrem[day], animpanel, 140, 210, 28, 28, daypicpos[day], 140, 130, 10, -10, 330, 40, 0)
    elif animstyle == 1:
        contractEngine(widget, daypicrem[day], animpanel, 28, 28, daypicpos[day], 140, 140, 210, 25, 26, 11, 7, 14, 21, 0, 40, 0)
    elif animstyle == 2:
        fadeOutEngine(widget, daypicrem[day], animpanel, "ddbg_alpha_", 26, 25, 210, 140, 0, 0, 0)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)

    ddon = 0
    otherdetail = 1
    
def createCurrentDetail(widget):
    global clock, weather, ddcbg, setcday, setccity, setcdate, setctime, setcwdir, setcwstr, setcbar, setcrtmp, setchum, setcvis, setcuv, ddcday, ddccity, ddcdate, ddctime, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv, ddcon, mainpic, clicky, animate, webpicon, dropdownflag, slideTextGrp, slideYPos, animpanel
    dropdownflag = 1
    #if altback == 1:
        #ddcbg = "background/ddc_bg9.png"
    #elif altback == 2:
        #ddcbg = "background/ddc_bg17.png"
    #elif altback == 3:
        #ddcbg = "background/ddc_bg21.png"
    #elif altback == 4:
        #ddcbg = "background/ddc_bg20.png"
    #elif altback == 5:
        #ddcbg = "background/ddc_bg17.png"
    #elif altback == 6:
        #ddcbg = "background/ddc_bg23.png"
    #elif altback == 7:
        #ddcbg = "background/ddc_bg24.png"
    #elif altback == 8:
        #ddcbg = "background/ddc_bg25.png"
    #elif flatflag == 1:
        #ddcbg = "background/ddc_bgflat.png"
    #else:
        #ddcbg = "background/ddc_bg.png"

    if animstyle == 0:
        dropDownEngine(widget, mainpic, ddcbg, 20, 196, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), 0, 0, 10, 140, 13, 136, 196, 36, 36, 33, 25, 0)
    
    elif animstyle == 1:
        expandEngine(widget, mainpic, ddcbg, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), 0, 0, 8, 10, 126, 89, 9, 6, 13, 19, 33, 25, 196, 136, 36, 36, 0)
    
    elif animstyle == 2:
        fadeInEngine(widget, mainpic, ddcbg, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), "ddcbg_alpha_", 33, 25, 196, 136, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,33,25,ddcbg)
    karamba.redrawWidget(widget)
    if textstyle == 0:
        xpos = 50
    else:
        xpos = 255
    setcday = karamba.createText(widget, xpos, 33, 200, 20, _('Current Situation:'))
    prettyText(widget, fontSizeMatrix[3], fontFamilyMatrix[3], shadow, setcday)
    if textstyle == 0:
        slideTextGrp = [setcday]
        emergeText(widget, slideTextGrp, 1, 12, 0)
    setccity = karamba.createText(widget, xpos, 47, 70, 20, _('City:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setccity)
    setctime = karamba.createText(widget, xpos, 59, 70, 20, _('Check:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setctime)
    setcdate = karamba.createText(widget, xpos, 71, 70, 20, _('Date:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcdate)
    setcwdir = karamba.createText(widget, xpos, 83, 70, 20, _('Wind:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcwdir)
    setcwstr = karamba.createText(widget, xpos, 95, 70, 20, _('Speed:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcwstr)
    setcbar = karamba.createText(widget, xpos, 107, 70, 20, _('PChange:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcbar)
    setcvis = karamba.createText(widget, xpos, 119, 70, 20, _('Visibility:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcvis)
    setcuv = karamba.createText(widget, xpos, 131, 70, 20, _('UV:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, setcuv)
    slideTextGrp = [setcday, setccity, setctime, setcdate, setcwdir, setcwstr, setcbar, setcvis, setcuv]
    slideYPos = [33, 47, 59, 71, 83, 95, 107, 119, 131]
    if textstyle == 0:
        slideTextGrp = [setccity, setctime, setcdate, setcwdir, setcwstr, setcbar, setcvis, setcuv]
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 50)

#     ddcday = karamba.createText(widget, 150, 30, 100, 20, "Today " + weather.weekday())
#     prettyText(widget, 17, "verdana", ddcday)
    if textstyle == 0:
        xpos1 = 120
    else:
        xpos1 = 255
    ddccity = karamba.createText(widget, xpos1, 47, 100, 20, weather.place())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddccity)

    # showing 24h clock?
    if clock: tmptimestr = weather.time()
    else:  tmptimestr = weather.get_12h_time()
    tmptimestr +=  ' ' + weather.timezone()
    ddctime = karamba.createText(widget, xpos1, 59, 100, 20, tmptimestr)
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddctime)
    ddcdate = karamba.createText(widget, xpos1, 71, 100, 20, weather.day() + " " + weather.month() + " " + weather.year())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcdate)
    if weather.wind() == "Variable":
        ddcwdir = karamba.createText(widget, xpos1, 83, 120, 20, _(weather.wind()))
    else:
        ddcwdir = karamba.createText(widget, xpos1, 83, 120, 20, weather.wind())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcwdir)
    ddcwstr = karamba.createText(widget, xpos1, 95, 70, 20, weather.wind_speed())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcwstr)
    ddcbar = karamba.createText(widget, xpos1, 107, 70, 20, _(weather.pressure_change()))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcbar)
    if weather.visibility() == "Unlimited":
        ddcvis = karamba.createText(widget, xpos1, 119, 70, 20, _(weather.visibility()))
    else:
        ddcvis = karamba.createText(widget, xpos1, 119, 70, 20, weather.visibility())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcvis)
    ddcuv = karamba.createText(widget, xpos1, 131, 70, 20, weather.uv())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ddcuv)
    slideTextGrp = [ddccity, ddctime, ddcdate, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv]
    slideYPos = [47, 59, 71, 83, 95, 107, 119, 131]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 1, 10, 0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 120)
    ddcon = 1
    dropdownflag = 0

def deleteCurrentDetail(widget):
    global ddcbg, setcday, setcdate, setctime, setcwdir, setcwstr, setcbar, setcvis, setcuv, ddcday, ddcdate, ddctime, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv, ddcon, mainpic, animate, otherdetail, slideTextGrp, slideYPos
    slideTextGrp = [setcday, setccity, setctime, setcdate, setcwdir, setcwstr, setcbar, setcvis, setcuv]
    slideYPos = [33, 47, 59, 71, 83, 95, 107, 119, 131]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 50, slideTextGrp, slideYPos, -150)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    slideTextGrp = [ddccity, ddctime, ddcdate, ddcwdir, ddcwstr, ddcbar, ddcvis, ddcuv]
    slideYPos = [47, 59, 71, 83, 95, 107, 119, 131]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 120, slideTextGrp, slideYPos, -155)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    #x = 40
    #y = 40
#     height = 120
#     width = 120
#     deg = -36
#     h1 = 136
#     w1 = 196
#     x = 33
#     y = 25
#     for i in range(10):
#         karamba.resizeImage(widget, ddcbg, w1, h1)
#         if animate == 0:
#             #karamba.resizeImage(widget, mainpic, x, y)
#             karamba.rotateImage(widget, mainpic, deg)
#             w = karamba.getImageWidth(widget,mainpic)
#             h = karamba.getImageHeight(widget,mainpic)
#             karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
#             deg = deg - 36
#         karamba.redrawWidget(widget)
#         karamba.moveImage(widget, ddcbg, x, y)
#         x = x + 9
#         y = y + 6
#         h1 = h1 - 13
#         w1 = w1 - 19
# 
#         #x = x + 8
#         #y = y + 8

     #widget, icon, panel, hStart, wStart, hIcon, wIcon, xIcon, yIcon, rangeStart, rangeEnd, rangeInc, degStart, degInc, mapFlag
    if animstyle == 0:
        rollUpEngine(widget, mainpic, animpanel, 0, 196, 120, 120, 0, 0, 136, 10, -13, -36, 36, 0)
    #karamba.deleteImage(widget, ddcbg)
    #widget, icon, panel, hIcon, wIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, xFinal, yFinal, hFinal, wFinal
    elif animstyle == 1:
        contractEngine(widget, mainpic, animpanel, 120, 120, 0, 0, 136, 196, 33, 25, 9, 6, 13, 19, -36, 36, 0)
        
    elif animstyle == 2:
        fadeOutEngine(widget, mainpic, animpanel, "ddcbg_alpha_", 33, 25, 196, 136, 0, 0, 0)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
#     karamba.removeImageTransformations(widget, mainpic)
#     karamba.redrawWidget
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)
    ddcon = 0
    otherdetail = 1

def createHourlyDetail1(widget):
    global hourly, hbg, mainpic, clicky, animate, hon, time_hour_rem, rain_hour_rem, wind_hour_rem, speed_hour_rem, temp_hour_rem, pic_hour_rem, headtime, headicon, headtemp, headrain, headwind, firsthour, headpage, dropdownflag, animpanel
    dropdownflag = 1
    #if altback == 1:
        #hbg = "background/ddc_bg9.png"
    #elif altback == 2:
        #hbg = "background/hbg17.png"
    #elif altback == 3:
        #hbg = "background/hbg21.png"
    #elif altback == 4:
        #hbg = "background/hbg20.png"
    #elif altback == 5:
        #hbg = "background/hbg17.png"
    #elif altback == 6:
        #hbg = "background/hbg23.png"
    #elif altback == 7:
        #hbg = "background/hbg24.png"
    #elif altback == 8:
        #hbg = "background/hbg25.png"
    #elif flatflag == 1:
        #hbg = "background/ddc_bgflat.png"
    #else:
        #hbg = "background/h_bg.png"
#     karamba.resizeImage(widget, hbg, 250, 20)
#     karamba.changeImageIntensity(widget, mainpic, 0.3, 0)
#     karamba.redrawWidget(widget)
#     #x = 108
#     #y = 108
#     deg = 36
#     height = 120
#     width = 120
#     for i in range(10,200,10):
#         karamba.resizeImage(widget, hbg, 250, i)
#         if animate == 0:
#             #karamba.resizeImage(widget, mainpic, x, y)
#             karamba.rotateImage(widget, mainpic, deg)
#             w = karamba.getImageWidth(widget,mainpic)
#             h = karamba.getImageHeight(widget,mainpic)
#             karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
#             deg = deg + 36
#         karamba.redrawWidget(widget)
#         #x = x - 8
#         #y = y - 8
#     karamba.resizeImage(widget, hbg, 250, 200)
    #widget, icon, panel, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, xFinal, yFinal, hFinal, wFinal, degStart, degInc, mapFlag
    if animstyle == 1:
        expandEngine(widget, mainpic, hbg, 110, 110, 0, 0, 0, 0, 125, 100, 13, 10, 20, 25, 0, 0, 250, 200, 36, 36, 0)
#widget, icon, panel, hStart, wStart, hIcon, wIcon, rangeStart, rangeEnd, rangeInc
    elif animstyle == 0:
        dropDownEngine(widget, mainpic, hbg, 20, 250, 110, 110, 0, 0, 10, 200, 10, 200, 250, 36, 36, 0, 0, 0)
        
    elif animstyle == 2:
        fadeInEngine(widget, mainpic, hbg, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), "hbg_alpha_", 0, 0, 250, 200, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,0,0,hbg)
    karamba.redrawWidget(widget)
    headtime = karamba.createText(widget, 10, 10, 70, 20, _("Time"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headtime)
    headicon = karamba.createText(widget, 50, 10, 70, 20, _("Sky"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headicon)
    headtemp = karamba.createText(widget, 84, 10, 70, 20, _("Temp"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headtemp)
    headrain = karamba.createText(widget, 118, 10, 70, 20, _("Rain"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headrain)
    headwind = karamba.createText(widget, 178, 10, 70, 20, _("Wind"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headwind)
    headpage = karamba.createText(widget, 218, 10, 70, 20, '(1/2)')
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headpage)
    titlesList = [headtime,headicon,headtemp,headrain,headwind,headpage]
    emergeText(widget,titlesList,1,10,0)
    #karamba.redrawWidget(widget)
    current_time = weather.time()
    cur_time_ind = current_time.find(':')
    current_time = int(current_time[:cur_time_ind])
    next_time = current_time + 1
    if next_time > 24:
        next_time = next_time - 24
    ypos = 38
    time_hour_rem = []
    pic_hour_rem = []
    temp_hour_rem = []
    rain_hour_rem = []
    wind_hour_rem = []
    speed_hour_rem = []
    main_rem = []
    #if textstyle == 0:
        #xpos = [10,50,84,118,158,188]
    #else:
        #xpos = [255,255,255,255,255,255]
    for i in range(6):
        hourtime = karamba.createText(widget, 255, ypos, 70, 20, str(next_time) + ':00')
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourtime)
        time_hour_rem.append(hourtime)
        houricon = karamba.createImage(widget, 255, ypos - 10, iconsetpath + hourly.get_forecast(i).icon_path())
        pic_hour_rem.append(houricon)
        hourtemp = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).temperature_high())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourtemp)
        temp_hour_rem.append(hourtemp)
        hourrain = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).rain())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourrain)
        rain_hour_rem.append(hourrain)
        hourwind = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).wind())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourwind)
        wind_hour_rem.append(hourwind)
        hourspeed = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).wind_speed())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourspeed)
        speed_hour_rem.append(hourspeed)
        ypos = ypos + 28
        next_time = next_time + 1
        if next_time > 24:
            next_time = next_time - 24
    slideTextGrp = time_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 10, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 10)
    slideTextGrp = pic_hour_rem
    slideYPos = [28, 56, 84, 112, 140, 168]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveImage(widget, slideTextGrp[i], 50, slideYPos[i])
        emergeIcon(widget, slideTextGrp,1,28,28,0)
    else:
        slideIcons(widget, 255, slideTextGrp, slideYPos, 50)
    situtext = _(hourly.get_forecast(i).sky())
    slideTextGrp = temp_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 84, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 84)
    slideTextGrp = rain_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 118, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 118)
    slideTextGrp = wind_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 158, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 158)
    slideTextGrp = speed_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 188, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 188)
    for i in range(6):
        situtext = _(hourly.get_forecast(i).sky())
        hourtooltip = karamba.addImageTooltip(widget, pic_hour_rem[i], situtext)

    hon = 1
    dropdownflag = 0
    
def deleteHourlyDetail1(widget):
    global hon, mainpic, animate, otherdetail
    headings = [headtime, headicon, headtemp, headrain, headwind, headpage]
    columns = [time_hour_rem, temp_hour_rem, rain_hour_rem, wind_hour_rem, speed_hour_rem]
    slideTextGrp = time_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 10, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = pic_hour_rem
    slideYPos = [28, 56, 84, 112, 140, 168]
    if textstyle == 0:
        emergeIcon(widget, slideTextGrp, 28, 1, 1, 1)
    else:
        slideIcons(widget, 50, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteImage(widget, i)
    slideTextGrp = temp_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 84, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = rain_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 118, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = wind_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 158, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = speed_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 188, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    emergeText(widget, headings, 10, 1, 1)
    for i in headings:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
    #x = 40
    #y = 40
#     height = 120
#     width = 120
#     deg = -36
#     for i in range(136,10,-13):
#         karamba.resizeImage(widget, hbg, 250, i)
#         if animate == 0:
#             #karamba.resizeImage(widget, mainpic, x, y)
#             karamba.rotateImage(widget, mainpic, deg)
#             w = karamba.getImageWidth(widget,mainpic)
#             h = karamba.getImageHeight(widget,mainpic)
#             karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
#             deg = deg - 36
#         karamba.redrawWidget(widget)
#         #x = x + 8
#         #y = y + 8
#     karamba.deleteImage(widget, hbg)
#     #if animate == 0:
#         #karamba.resizeImage(widget, mainpic, 120, 120)
#     karamba.removeImageTransformations(widget, mainpic)
#     karamba.redrawWidget
    #widget, icon, panel, hIcon, wIcon, xIcon, yIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, degStart, degInc, mapFlag
    if animstyle == 1:
        contractEngine(widget, mainpic, animpanel, 110, 110, 0, 0, 200, 250, 0, 0, 13, 10, 20, 25, -36, 36, 0)
##widget, icon, panel, hStart, wStart, hIcon, wIcon, rangeStart, rangeEnd, rangeInc
    elif animstyle == 0:
        rollUpEngine(widget, mainpic, animpanel, 0, 250, 110, 110, 0, 0, 200, 10, -20, -36, 36, 0)
    elif animstyle == 2:
        fadeOutEngine(widget, mainpic, animpanel, "hbg_alpha_", 0, 0, 250, 200, 0, 0, 0)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)

    hon = 0
    firsthour = 1
    otherdetail = 0

def createHourlyDetail2(widget):
    global hourly, hbg2, mainpic, clicky, animate, time_hour_rem, rain_hour_rem, wind_hour_rem, speed_hour_rem, temp_hour_rem, pic_hour_rem, hon2, sub_hour_rem2, main_hour_rem2, pic_hour_rem2, headtime2, headicon2, headtemp2, headrain2, headwind2, headpage2, dropdownflag, animpanel
    dropdownflag = 1
    #if altback == 1:
        #hbg2 = "background/ddc_bg9.png"
    #elif altback == 2:
        #hbg2 = "background/hbg17.png"
    #elif altback == 3:
        #hbg2 = "background/hbg21.png"
    #elif altback == 4:
        #hbg2 = "background/hbg20.png"
    #elif altback == 5:
        #hbg2 = "background/hbg17.png"
    #elif altback == 6:
        #hbg2 = "background/hbg23.png"
    #elif altback == 7:
        #hbg2 = "background/hbg24.png"
    #elif altback == 8:
        #hbg2 = "background/hbg25.png"
    #elif flatflag == 1:
        #hbg2 = "background/ddc_bgflat.png"
    #else:
        #hbg2 = "background/h_bg.png"
    if animstyle == 1:
        expandEngine(widget, mainpic, hbg2, 110, 110, 0, 0, 0, 0, 125, 100, 13, 10, 20, 25, 0, 0, 250, 200, 36, 36, 0)
    elif animstyle == 0:
        dropDownEngine(widget, mainpic, hbg2, 20, 250, 110, 110, 0, 0, 10, 200, 10, 200, 250, 36, 36, 0, 0, 0)
    elif animstyle == 2:
        fadeInEngine(widget, mainpic, hbg2, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), "hbg_alpha_", 0, 0, 250, 200, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,0,0,hbg2)
    karamba.redrawWidget(widget)
#     karamba.resize Image(widget, hbg2, 250, 20)
#     karamba.changeImageIntensity(widget, mainpic, 0.3, 0)
#     karamba.redrawWidget(widget)
#     #x = 108
#     #y = 108
#     deg = 36
#     height = 120
#     width = 120
#     for i in range(10,200,10):
#         karamba.resizeImage(widget, hbg2, 250, i)
#         if animate == 0:
#             #karamba.resizeImage(widget, mainpic, x, y)
#             karamba.rotateImage(widget, mainpic, deg)
#             w = karamba.getImageWidth(widget,mainpic)
#             h = karamba.getImageHeight(widget,mainpic)
#             karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
#             deg = deg + 36
#         karamba.redrawWidget(widget)
#         #x = x - 8
#         #y = y - 8
#     karamba.resizeImage(widget, hbg2, 250, 200)
    headtime2 = karamba.createText(widget, 10, 10, 70, 20, _("Time"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headtime2)
    headicon2 = karamba.createText(widget, 50, 10, 70, 20, _("Sky"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headicon2)
    headtemp2 = karamba.createText(widget, 84, 10, 70, 20, _("Temp"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headtemp2)
    headrain2 = karamba.createText(widget, 118, 10, 70, 20, _("Rain"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headrain2)
    headwind2 = karamba.createText(widget, 178, 10, 70, 20, _("Wind"))
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headwind2)
    headpage2 = karamba.createText(widget, 218, 10, 70, 20, '(2/2)')
    prettyText(widget, fontSizeMatrix[4], fontFamilyMatrix[4], shadow, headpage2)
    titlesList = [headtime2,headicon2,headtemp2,headrain2,headwind2,headpage2]
    emergeText(widget,titlesList,1,10,0)
    current_time2 = weather.time() 
    cur_time_ind2 = current_time2.find(':')
    current_time2 = int(current_time2[:cur_time_ind2])
    next_time2 = current_time2 + 7
    if next_time2 > 24:
        next_time2 = next_time2 - 24
    ypos = 38
    time_hour_rem = []
    pic_hour_rem = []
    temp_hour_rem = []
    rain_hour_rem = []
    wind_hour_rem = []
    speed_hour_rem = []
    main_rem = []
    for i in range(6,12):
        hourtime2 = karamba.createText(widget, 255, ypos, 70, 20, str(next_time2) + ':00')
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourtime2)
        time_hour_rem.append(hourtime2)
        houricon2 = karamba.createImage(widget, 255, ypos - 10, iconsetpath + hourly.get_forecast(i).icon_path())
##        situtext = _(hourly.get_forecast(i).sky())
##        if situtext == None:
##            situtext = hourly.get_forecast(i).sky()
##            transError(widget, hourly.get_forecast(i).sky())
##        hourtooltip2 = karamba.addImageTooltip(widget, houricon2, hourly.get_forecast(i).sky())
        pic_hour_rem.append(houricon2)
        hourtemp2 = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).temperature_high())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourtemp2)
        temp_hour_rem.append(hourtemp2)
        hourrain2 = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).rain())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourrain2)
        rain_hour_rem.append(hourrain2)
        hourwind2 = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).wind())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourwind2)
        wind_hour_rem.append(hourwind2)
        hourspeed2 = karamba.createText(widget, 255, ypos, 70, 20, hourly.get_forecast(i).wind_speed())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hourspeed2)
        speed_hour_rem.append(hourspeed2)
        ypos = ypos + 28
        next_time2 = next_time2 + 1
        if next_time2 > 24:
            next_time2 = next_time2 - 24
    slideTextGrp = time_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 10, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 10)
    slideTextGrp = pic_hour_rem
    slideYPos = [28, 56, 84, 112, 140, 168]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveImage(widget, slideTextGrp[i], 50, slideYPos[i])
        emergeIcon(widget, slideTextGrp,1,28,28,0)
    else:
        slideIcons(widget, 255, slideTextGrp, slideYPos, 50)
    slideTextGrp = temp_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 84, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 84)
    slideTextGrp = rain_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 118, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 118)
    slideTextGrp = wind_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 158, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 158)
    slideTextGrp = speed_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        for i in range(len(slideTextGrp)):
            karamba.moveText(widget, slideTextGrp[i], 188, slideYPos[i])
        emergeText(widget, slideTextGrp,1,10,0)
    else:
        slideText(widget, 255, slideTextGrp, slideYPos, 188)
    for i in range(6,12):
        situtext = _(hourly.get_forecast(i).sky())
        hourtooltip = karamba.addImageTooltip(widget, pic_hour_rem[i-6], situtext)
    hon2 = 1
    dropdownflag = 0
        
def deleteHourlyDetail2(widget):
    global hon2, mainpic, animate, otherdetail
    headings = [headtime2, headicon2, headtemp2, headrain2, headwind2, headpage2]
    columns = [time_hour_rem, temp_hour_rem, rain_hour_rem, wind_hour_rem, speed_hour_rem]
    slideTextGrp = time_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 10, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = pic_hour_rem
    slideYPos = [28, 56, 84, 112, 140, 168]
    if textstyle == 0:
        emergeIcon(widget, slideTextGrp, 28, 1, 1, 1)
    else:
        slideIcons(widget, 50, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteImage(widget, i)
    slideTextGrp = temp_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 84, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = rain_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 118, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = wind_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 158, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    slideTextGrp = speed_hour_rem
    slideYPos = [38, 66, 94, 122, 150, 178]
    if textstyle == 0:
        emergeText(widget, slideTextGrp, 10, 1, 1)
    else:
        slideText(widget, 188, slideTextGrp, slideYPos, -50)
    for i in slideTextGrp:
        karamba.deleteText(widget, i)
    emergeText(widget, headings, 10, 1, 1)
    for i in headings:
        karamba.deleteText(widget, i)
    karamba.redrawWidget(widget)
#     #x = 40
#     #y = 40
#     height = 120
#     width = 120
#     deg = -36
#     for i in range(136,10,-13):
#         karamba.resizeImage(widget, hbg2, 250, i)
#         if animate == 0:
#             #karamba.resizeImage(widget, mainpic, x, y)
#             karamba.rotateImage(widget, mainpic, deg)
#             w = karamba.getImageWidth(widget,mainpic)
#             h = karamba.getImageHeight(widget,mainpic)
#             karamba.moveImage(widget,mainpic,0-((w-width)/2),0-((h-height)/2))
#             deg = deg - 36
#         karamba.redrawWidget(widget)
#         #x = x + 8
#         #y = y + 8
#     karamba.deleteImage(widget, hbg2)
#     #if animate == 0:
#         #karamba.resizeImage(widget, mainpic, 120, 120)
#     karamba.removeImageTransformations(widget, mainpic)
#     karamba.redrawWidget
    if animstyle == 1:
        contractEngine(widget, mainpic, animpanel, 110, 110, 0, 0, 200, 250, 0, 0, 13, 10, 20, 25, -36, 36, 0)
    elif animstyle == 0:
        rollUpEngine(widget, mainpic, animpanel, 0, 250, 110, 110, 0, 0, 200, 10, -20, -36, 36, 0)
    elif animstyle == 2:
        fadeOutEngine(widget, mainpic, animpanel, "hbg_alpha_", 0, 0, 250, 200, 0, 0, 0)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)

    hon2 = 0
    otherdetail = 1

# Functions to parse weather data using regular expressions
def parseWeatherData(data, days):
    # Parses an xml page from weather.com and returns a list
    # containing the current weather conditions and forecast.

    # data: An unmodified xml page from weather.com
    # days: Number of forecast days (including today) to return (maximum 10)
    global dnamobst, latitude, longitude, stormmonth, stormday, stormyear, moon_icon, moon_phase
    import re
    import weather

    # Make sure we don't try to get any more than 5 day's forecast
    if days > 5: days = 5

    data = data.replace('CALM', 'Variable')
    data = data.replace('VAR','Variable')
    data = data.replace('calm', '0')
    data = data.replace('<dewp>N/A</dewp>', '<dewp>0</dewp>')
    dnamstart = data.find('<dnam>')
    dnamstop = data.find('</dnam>')
    al_city_match = re.search('<dnam>(?P<city>.*?),', data[dnamstart:dnamstop])
    dcstart = data.find('<cc>')
    dcstop = data.find('</cc>')
    data_current = data[dcstart:dcstop]
    latstart = data.find('<lat>')
    latstop = data.find('</lat>')
    latitude = data[(latstart + 5):latstop]
    lonstart = data.find('<lon>')
    lonstop = data.find('</lon>')
    longitude = data[(lonstart + 5):lonstop]

    day0 = data.find('<day d="0"')
    day1 = data.find('<day d="1"')
    day2 = data.find('<day d="2"')
    day3 = data.find('<day d="3"')
    day4 = data.find('<day d="4"')
    data0 = data[day0:day1]
    data1 = data[day1:day2]
    data2 = data[day2:day3]
    data3 = data[day3:day4]
    data4 = data[day4:]


    p_report = r'''(?ix)
    .*<lsup>(?P<month>\d+?)/ # Month
    (?P<day>\d+?)/ # Day
    (?P<year>\d+?) # Year
    \s(?P<time>.+?)\s #Time
    (?P<meridian>[A|P]M) # AM or PM
    \s(?P<zone>.*?)</lsup> # time zone
    \s*<obst>(?P<city>.*?), # City
    '''




    # time and location of the weather report
    now = weather.Observation()
    match = re.search(p_report, data_current)
    if match:
        stormyear = '20' + match.group('year')
        stormmonth = match.group('month')
        stormday = match.group('day')
        now.year(match.group('year'))
        now.month(match.group('month'))
        now.day(match.group('day'))
        now.time(match.group('time'), match.group('meridian'))
        now.timezone(match.group('zone'))
        print "dnamobst: " + str(dnamobst)
        if al_city_match and dnamobst == 1:
             now.place(al_city_match.group('city'))
        else:
            now.place(match.group('city'))

    p_weekday = r'''(?ix)
    <day\sd=\"0\"\st=\"(?P<weekday>.+?)\" # Day of the week
    '''

    match1 = re.search(p_weekday, data0)
    if match1:
        now.weekday(match1.group('weekday')[:3])


    p_current = r'''(?isx) # Ignore case, Dot matches all, Verbose
    .*<tmp>(?P<temp>.*?|N/A)</tmp> # Temp
    \s*<flik>(?P<heat>.*?|N/A)</flik> # Heat
    \s*<t>(?P<sky>\D+?)</t> # Sky
    \s*<icon>(?P<icon>.*?)</icon> # Icon
    \s*<bar>\s*<r>(?P<baro>.*?)</r>\s*<d>(?P<change>.*?)</d>\s*</bar>
    \s*<wind>\s*<s>(?P<speed>.*?)</s>.*<t>(?P<wind>.*?)</t>\s*</wind>
    \s*<hmid>(?P<hum>(.*?|N/A))</hmid>
    \s*<vis>(?P<vis>.*?)</vis>
    \s*<uv>\s*<i>(?P<uv>(.*?|N/A))</i>
    .*<dewp>(?P<dew>(.*?|N/A))</dewp>
    .*?<moon>.*<icon>(?P<moon_icon>(.*?|N/A))</icon>
    .*?<t>(?P<moon_phase>.*?)</t>
    '''


    match = re.search(p_current, data_current)
    if match:
        if (match.group('icon')) == '-':
            now.icon('na')
        else:
            now.icon(match.group('icon'))
        if match.group('temp') == 'N/A':
            now.relative_heat(None)
        else:
            now.temperature(match.group('temp'), 'F')
        if match.group('heat') == 'N/A':
            now.relative_heat(None)
        else:
            now.relative_heat(match.group('heat'), 'F')
        now.sky(match.group('sky'))
        now.uv(match.group('uv'))
        now.dewpoint(match.group('dew'), 'F')
        now.humidity(match.group('hum'))
        now.visibility(match.group('vis'), 'mi')
        now.pressure(match.group('baro'), 'inHg')
        now.pressure_change(match.group('change'))
        if match.group('wind') != 'CALM':
            mywind =  match.group('wind')
            gusting = mywind.find('gusting')
            if gusting != -1:
                jat = mywind.find(' at')
                mywind = mywind[:jat]
            now.wind(mywind.replace('From the ', ''))
            
        now.wind_speed(match.group('speed'), 'mph')
        moon_phase = match.group('moon_phase')
        moon_icon = moon_map.get(moon_phase)
    print now


    p_today = r'''(?isx) # Ignore case, Dot matches all, Verbose
    <day\sd=\"0\".*dt=\"(?P<date>.*?)\"> # Date
    \s*?<hi>(?P<high>(.*?|N/A))</hi> # High temperature
    \s*?<low>(?P<low>(.*?|N/A))</low> # Low temperature
    .*?<icon>(?P<icon>\d*?)</icon> # Icon
    \s*?<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>\d+)</ppcp>  # Chance of rain
    '''

    today = weather.Forecast(now.weekday())
    now.add_forecast(today)
    match = re.search(p_today, data0)
    if match:
        today.icon(match.group('icon'))
        today.sky(match.group('sky'))
        today.date(match.group('date'))
        if match.group('high') != 'N/A':
            today.temperature_high(match.group('high'), 'F')
        today.temperature_low(match.group('low'), 'F')
        today.rain(match.group('rain'));

    print "+++++++++++++++++++Today\'s Forecast++++++++++++++++++++++++"
    print today
    p_forecast = r'''(?isx) # No embedded flags, since they will be added later
    .*?t=\"(?P<day>.*?)\" # Weekday
    .*?dt=\"(?P<date>.*?)\"> # Day number
    \s*?<hi>(?P<high>.*?)</hi> # High temperature
    \s*?<low>(?P<low>.*?)</low> # Low temperature
    .*?<icon>(?P<icon>\d*?)</icon> # Icon
    \s*?<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>\d+)</ppcp>  # Chance of rain
    '''
    datalist = [data1, data2, data3, data4]
    day = 1
    while day <= (days -1):
        forecast = weather.Forecast()
        now.add_forecast(forecast)
        match = re.search(p_forecast, datalist[day-1])
        if match:
            forecast.weekday(match.group('day')[:3])
            forecast.date(match.group('date'))
            forecast.icon(match.group('icon'))
            forecast.sky(match.group('sky'))
            forecast.temperature_high(match.group('high'), 'F')
            forecast.temperature_low(match.group('low'), 'F')
            forecast.rain(match.group('rain'));
        day += 1
        print forecast

    return now

def parseHourly(widget, data):
    import re
    import weather
    crapstop = data.find('<hbhf>')
    data = data[crapstop:]
    
    
    hour0 = data.find('<hour h="1"')
    hour1 = data.find('<hour h="2"')
    hour2 = data.find('<hour h="3"')
    hour3 = data.find('<hour h="4"')
    hour4 = data.find('<hour h="5"')
    hour5 = data.find('<hour h="6"')
    hour6 = data.find('<hour h="7"')
    hour7 = data.find('<hour h="8"')
    hour8 = data.find('<hour h="9"')
    hour9 = data.find('<hour h="10"')
    hour10 = data.find('<hour h="11"')
    hour11 = data.find('<hour h="12"')
    data0 = data[hour0:hour1]
    data1 = data[hour1:hour2]
    data2 = data[hour2:hour3]
    data3 = data[hour3:hour4]
    data4 = data[hour4:hour5]
    data5 = data[hour5:hour6]
    data6 = data[hour6:hour7]
    data7 = data[hour7:hour8]
    data8 = data[hour8:hour9]
    data9 = data[hour9:hour10]
    data10 = data[hour10:hour11]
    data11 = data[hour11:]
    nowhourly = weather.Observation()
    p_forecast = r'''(?isx) # No embedded flags, since they will be added later
    .*?<tmp>(?P<temp>.*?)</tmp> # Temp
    \s*<flik>(?P<heat>.*?)</flik> # Heat
    \s*<icon>(?P<icon>.*?)</icon> # Icon
    \s*<t>(?P<sky>.*?)</t> # Sky
    .*?<ppcp>(?P<rain>.*?)</ppcp>
    \s*<wind>\s*<s>(?P<speed>.*?)</s>.*<t>(?P<wind>.*?)</t>\s*</wind>
    .*?<hmid>(?P<hum>(.*?|N/A))</hmid>
    '''
    datalist = [data0, data1, data2, data3, data4, data5, data6, data7, data8, data9, data10, data11,]
    
    for i in range(12):
        forecast = weather.Forecast()
        nowhourly.add_forecast(forecast)
        match = re.search(p_forecast, datalist[i])
        if match:
            forecast.temperature_high(match.group('temp'))
            forecast.temperature_low(match.group('heat'))
            forecast.icon(match.group('icon'))
            forecast.sky(match.group('sky'))
            forecast.rain(match.group('rain'))
            forecast.wind(match.group('wind'))
            if match.group('speed') == 'calm':
                forecast.wind_speed(0, 'mph')
            else:
                forecast.wind_speed(match.group('speed'), 'mph')
            forecast.humidity(match.group('hum'))
    return nowhourly
    

def parseBBCWeatherData(data, days):
    '''Parses a page from weather.com and returns a list
    containing the current weather conditions and forecast.

    data: An unmodified html page from weather.com

    days: Number of forecast days to return (maximum 9)
    '''
    global longitude, latitude, stormday, stormmonth, stormyear
    import re
    import weather

    #this maps bbc weather icons into widget icons
    iconmap = {'0':'31', '1':'32', '2':'26', '3':'28', '4':'4', '5':'22',
            '6':'21', '7':'26', '8':'26', '9':'6', '10':'9', '11':'6', '12':'6',
            '13':'12', '14':'9', '15':'12', '16':'8', '17':'8', '18':'8', '19':'15',
            '20':'15', '21':'15', '22':'14', '23':'13', '24':'14', '25':'15',
            '26':'15', '27':'15', '28':'27', '29':'17', '30':'4', '31':'2', '32':'20',
            '100':'25'}

    #'1':'31', '3':'27',
    # '32':'31', '28':'27',
    # Make sure we don't try to get any more than 5 day's forecast
    if days > 5: days = 5

    # Chop the data into more managable size
    start = data.find('<!-- global nav close -->')
    stop = data.find('</body>')
    data1 = data[start:stop]
    p_lon_lat = r'Latitude</strong>:\s(?P<latitude>.+),<br\s/><strong>Longitude</strong>:\s(?P<longitude>.+)\.<br'
    match = re.search(p_lon_lat, data1)
    if match:
        longitude = match.group('longitude')
        latitude = match.group('latitude')
    # The regular expressions needed to get the weather forecast
    
    # time and location of the weather report
    now = weather.Observation()
    
    p_city = r'<h1 style="text-transform:capitalize;">(?P<city>.+?),'
    match = re.search(p_city, data1)
    if match:
            match_city = match.group('city')
            now.place(match_city)
    
    p_time = r'''(?ix)
    Observed</strong>:\s
    (?P<weekday>\w+)\s
    (?P<day>\d+)/(?P<month>\d+)/(?P<year>\d+)\s 
    at \s <br \s />
    (?P<time>\d+)'''
    match = re.search(p_time, data1)
    if match:
        stormyear = match.group('year')
        stormmonth = match.group('month')
        stormday = match.group('day')
        now.year(match.group('year'))
        now.month(match.group('month'))
        now.day(match.group('day'))
        now.weekday(match.group('weekday'))
        now.time(match.group('time'))
        now.timezone('GMT')
    
    #current observations
    p_current =  r'''(?isx)
    Nearest\sObservations
    .*?<span\sstyle="text-transform:capitalize;">(?P<sky>.*)</span>\s(?P<temp>.+?)<abbr
    .*?C</abbr><br\s/>(?P<wind>[^\(]+)\s?\((?P<speed>.*)\s<abbr
    .*?Relative\shumidity.*?</strong>:\s?(?P<hum>\d+),
    .*?<strong>Pressure.*?</strong>:\s(?P<baro>.*?),\s(?P<change>.*?),<
    .*?Visibility</strong>:\s(?P<vis>[^<]+)<
    '''
    match = re.search(p_current, data1)
    if match:
        now.sky(match.group('sky'))
        now.temperature(match.group('temp'))
        now.wind_speed(match.group('speed'),'mph')
        now.wind(match.group('wind'))
        now.humidity(match.group('hum'))
        now.pressure(match.group('baro'))
        now.pressure_change(match.group('change'))
        now.visibility(match.group('vis'))
    
    # day today:
    
    p_1day = r'''(?isx)
    day \s one\s///////\s-->.*?<strong>(?P<day>.\w{2})
    .*? strong&gt;(?P<desc>.*?)&lt;/strong
    .*? fiveday_sym/(?P<icon>\d+).gif
    .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    '''
    match = re.search(p_1day, data1)
    if match:
        now.icon(iconmap[match.group('icon')])
        today = weather.Forecast(match.group('day'))
        now.add_forecast(today)
        today.icon(iconmap[match.group('icon')])
        today.sky(match.group('desc').replace('.',''))
        today.temperature_high(match.group('max'))
        today.temperature_low(match.group('min'))
        today.wind_speed(match.group('speed'), 'mph')
        today.wind(match.group('wind'))
        today.visibility(match.group('visib'))
        today.pressure(match.group('pressu'))
        today.humidity(match.group('humidi'))
    
    if len(now.forecasts) == 0:
            print "Can not parse forecast - today"
    
    p_2day = r'''(?isx)
    day \s two\s///////\s-->.*?<strong>(?P<day>.\w{2})
    .*? strong&gt;(?P<desc>.*?)&lt;/strong
    .*? fiveday_sym/(?P<icon>\d+).gif
    .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    '''
    match = re.search(p_2day, data1)
    if match:
        day1 = weather.Forecast(match.group('day'))
        now.add_forecast(day1)
        day1.icon(iconmap[match.group('icon')])
        day1.sky(match.group('desc').replace('.',''))
        day1.temperature_high(match.group('max'))
        day1.temperature_low(match.group('min'))
        day1.wind_speed(match.group('speed'), 'mph')
        day1.wind(match.group('wind'))
        day1.visibility(match.group('visib'))
        day1.pressure(match.group('pressu'))
        today.humidity(match.group('humidi'))
    
    p_3day = r'''(?isx)
    day \s three\s///////\s-->.*?<strong>(?P<day>.\w{2})
    .*? strong&gt;(?P<desc>.*?)&lt;/strong
    .*? fiveday_sym/(?P<icon>\d+).gif
    .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    '''
    match = re.search(p_3day, data1)
    if match:
        day2 = weather.Forecast(match.group('day'))
        now.add_forecast(day2)
        day2.icon(iconmap[match.group('icon')])
        day2.sky(match.group('desc').replace('.',''))
        day2.temperature_high(match.group('max'))
        day2.temperature_low(match.group('min'))
        day2.wind_speed(match.group('speed'), 'mph')
        day2.wind(match.group('wind'))
        day2.visibility(match.group('visib'))
        day2.pressure(match.group('pressu'))
        day2.humidity(match.group('humidi'))
    
    p_4day = r'''(?isx)
    day \s four\s///////\s-->.*?<strong>(?P<day>.\w{2})
    .*? strong&gt;(?P<desc>.*?)&lt;/strong
    .*? fiveday_sym/(?P<icon>\d+).gif
    .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? <strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    '''
    match = re.search(p_4day, data1)
    if match:
        day3 = weather.Forecast(match.group('day'))
        now.add_forecast(day3)
        day3.icon(iconmap[match.group('icon')])
        day3.sky(match.group('desc').replace('.',''))
        day3.temperature_high(match.group('max'))
        day3.temperature_low(match.group('min'))
        day3.wind_speed(match.group('speed'), 'mph')
        day3.wind(match.group('wind'))
        day3.visibility(match.group('visib'))
        day3.pressure(match.group('pressu'))
        day3.humidity(match.group('humidi'))
    
    p_5day = r'''(?isx)
    day \s five\s///////\s-->.*?<strong>(?P<day>.\w{2})
    .*? strong&gt;(?P<desc>.*?)&lt;/strong
    .*? fiveday_sym/(?P<icon>\d+).gif
    .*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? <strong>(?P<min>[\d/-]+) <abbr \s title="Night
    .*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
    .*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
    '''
    match = re.search(p_5day, data1)
    if match:
        day4 = weather.Forecast(match.group('day'))
        now.add_forecast(day4)
        day4.icon(iconmap[match.group('icon')])
        day4.sky(match.group('desc').replace('.',''))
        day4.temperature_high(match.group('max'))
        day4.temperature_low(match.group('min'))
        day4.wind_speed(match.group('speed'), 'mph')
        day4.wind(match.group('wind'))
        day4.visibility(match.group('visib'))
        day4.pressure(match.group('pressu'))
        day4.humidity(match.group('humidi'))
    
    if len(now.forecasts) == 0:
            print "Can not parse forecast - day1"
    
    
    print now
    print 'fore------------------------------'
    print today
    print day1
    print day2
    print day3
    print day4
    print '------------------------------fore'

    
    return now

def getWeather(widget):
    #setup data structures
    global url, installed, metric_units, days, windy

    # DAVE
    w = None
    h = None

    if installed[0] == '~':
        home = expanduser('~')
        installed = home + installed[1:]
    filename = installed + '/karamba_weather.html'
    filenamehourly = installed + '/karamba_hourly.html'
    try:
        data = urllib2.urlopen(url).read()
        if use_wcom == 1:
            print 'using weather.com'
            hourlyurl = 'http://xoap.weather.com/weather/local/' + wcomcode + '?cc=*&dayf=1&unit=m&hbhf=12'
            datahourly = urllib2.urlopen(hourlyurl).read()
        if data.find('BBC Weather') > 0:
            print "parsing BBC"
            w = parseBBCWeatherData(data, days)
        else:
            print "parsing XML"
            w = parseWeatherData(data, days)
            h = parseHourly(widget, datahourly)
        try:
            getStormFlag(widget)
        except:
            pass
        save = open(filename, 'w')
        print >> save, data
        save.close()
        if use_wcom == 1:
            savehourly = open(filenamehourly, 'w')
            print >> savehourly, datahourly
            savehourly.close()
        
    except: # Maybe we're offline?
        print "Exception encountered."
        try: # Try to load the saved weather data
            data =  open(installed + '/karamba_weather.html', 'r').read()
            if use_wcom == 1:
                datahourly = open(installed + '/karamba_hourly.html', 'r').read()
            if data.find('<title>BBC') > 0:
                w = parseBBCWeatherData(data,  days)
            else:
                w = parseWeatherData(data, days)
                h = parseHourly(widget, datahourly)
            if connect_warn == 0:
                os.system('kdialog --title "%s" --error "%s" &' %(_('Download Error'),_('Liquid Weather ++ was unable to download data for some reason.  Liquid Weather ++ was loaded using the last available data.'))) 
        except:
            print "Fatal Error; Cannot connect to site or load old data"
            os.system('kdialog --title "%s" --error "%s" &' %(_('Download Error'),_('Liquid Weather ++ was unable to download data for some reason.  There is no cached data available.  \nLiquid Weather ++ has exited.')))
            exit 
    if use_wcom == 1:
        h.metric(metric_units)
        h.reverse_wind_arrows(windy)
    w.metric(metric_units)
    w.reverse_wind_arrows(windy)
    
    # DAVE
    return (w,h)


def getWebcamPic(widget, cam_index):
    global filename, nowebcams
    filenames = []
    nowebcams = int(nowebcams)
    try:
        picture = urllib2.urlopen(webcamurls[cam_index]).read()
        filename = config_directory + '/webcampic_' + str(cam_index) + '.jpg'
        save = open(filename, 'w')
        print >> save, picture
        save.close()
        if animstyle == 2:
            alpha = 0.1
            for i in range(10):
                os.system('convert %s -resize 216x166 -matte -channel A -evaluate multiply %s %s' %(config_directory + '/webcampic_' + str(cam_index) + '.jpg', alpha, config_directory + '/fade/web_alpha_' + str(i) + '.png'))
                alpha = alpha + 0.1

    except:
        filename = 'webcam_failed.png'



def getSatPic(widget, incontinent, imap):
    global satfile
    satpicurl = prefix + countries[incontinent] + map_matrix[incontinent][imap] + '.gif'
#    errorpath = "webcam_failed.png"
    try:
        picture = urllib2.urlopen(satpicurl).read()
        satfile = config_directory + '/satpic.jpg'
        save = open(satfile, 'w')
        print >> save, picture
        save.close()
        alpha = 0.1
        for i in range(10):
            os.system('convert %s -matte -channel A -evaluate multiply %s %s' %(config_directory + '/satpic.jpg', alpha, config_directory + '/fade/sat_alpha_' + str(i) + '.png'))
            alpha = alpha + 0.1

    except:
        picture = 'webcam_failed.png'

def createMapMenu(widget, cont_num):
    global webcammenu, satbuttmenu, mapmenu, selection
    karamba.deleteMenu(widget, satbuttmenu)
    karamba.deleteMenu(widget, webcammenu)
    karamba.deleteMenu(widget, mapmenu)
    webcammenu = 0
    satbuttmenu = 0
    mapmenu = karamba.createMenu(widget)
    selection = []
    for i in range(len(map_matrix[cont_num])):
        item = karamba.addMenuItem(widget, mapmenu, mapitemsconvert[cont_num][i], "")
        #sorts out the id of the item clicked so it's useful
        #id seems to be negative value, convert to positive
        if item < 0:
            item = item * -1
        selection.append(item)
    karamba.popupMenu(widget, mapmenu, 30, 56)

def transError(widget, sky):
    errordiagcommand = ['kdialog', '--title', _(sky), '--error', "<p>%s</p>" %(_('There is no translation for the sky conditions for your language.  Please email the developer at dmbkiwi@yahoo.com with the language and a translation.').encode('ascii','xmlcharrefreplace'))]
    errorpid = karamba.executeInteractive(widget, errordiagcommand)

def getStormFlag(widget):
    global stormFlag
    URL = "http://www.solar.ifa.hawaii.edu/Tropical/Data/tropical"
    data = urllib2.urlopen(URL).readlines()
    for i in range(len(data)):
        data[i] = data[i].strip('\n')
        data[i] = data[i].split()
    stormdata = []
    startflag = 0
    for i in range(len(data)):
        if (int(data[i][1]) == int(stormmonth)) and (int(data[i][2]) == int(stormday)) and (int(data[i][0]) == int(stormyear)):
            startflag = 1
        if startflag == 1:
            stormdata.append(data[i])
    for i in range(len(stormdata)):
        interimflag = 0
        if stormdata[i][6] == 'S':
            stormdata[i][5] = float(stormdata[i][5]) * -1
        if stormdata[i][8] == 'W':
            stormdata[i][7] = float(stormdata[i][7]) * -1
        if (float(stormdata[i][5]) < (float(latitude) + 10)) and (float(stormdata[i][5]) > (float(latitude) - 10)):
            interimflag = interimflag + 1
        if (float(stormdata[i][7]) < (float(longitude) + 10)) and (float(stormdata[i][7]) > (float(longitude) - 10)):
            interimflag = interimflag + 1
        if interimflag == 2:
            stormFlag = 1
            break
    print "stormFlag = " + str(stormFlag)
    
def emergeText(widget, texts, startSize, finalSize, direction):
    if direction == 0:
        cycles = finalSize - startSize
    else:
        cycles = startSize - finalSize
    if animate == 0:
        for i in texts:
            karamba.changeTextSize(widget, i, startSize)
        karamba.redrawWidget(widget)
        for i in range(cycles):
            for j in texts:
                #print karamba.getTextFontSize(widget,j)
                if direction == 0:
                    karamba.changeTextSize(widget, j, (karamba.getTextFontSize(widget,j) + 1))
                else:
                    karamba.changeTextSize(widget, j, (karamba.getTextFontSize(widget,j) - 1))
            t = float(time.time())
            while (t + animdelay) > float(time.time()):
                pass
            karamba.redrawWidget(widget)
        for j in texts:
            karamba.changeTextSize(widget, j, finalSize)
        karamba.redrawWidget(widget)
    else:
        karamba.redrawWidget(widget)

def emergeIcon(widget, icons, startSize, finalSizew, finalSizeh, direction):
    if direction == 0:
        increment = (finalSizew - startSize)/10
    else:
        increment = (startSize - finalSizew)/10
    if animate == 0:
        for i in icons:
            karamba.resizeImage(widget, i, startSize, startSize)
        for i in range(10):
            for j in icons:
                if direction == 0:
                    karamba.resizeImage(widget, j, (karamba.getImageWidth(widget, j) + increment), (karamba.getImageHeight(widget, j) + increment))
                else:
                    karamba.resizeImage(widget, j, (karamba.getImageWidth(widget, j) - increment), (karamba.getImageHeight(widget, j) - increment))
            t = float(time.time())
            while (t + animdelay) > float(time.time()):
                pass
            karamba.redrawWidget(widget)
        for j in icons:
            karamba.resizeImage(widget, j, finalSizew, finalSizeh)
        karamba.redrawWidget(widget)
    else:
        karamba.redrawWidget(widget)

def slideText(widget, startX, texts, startY, finalX):
    cycles = ((startX - finalX)/20) + len(texts)
    xtrans = []
    if animate == 0:
        for i in range(len(texts)):
            xtrans.append(startX)
        for i in range(cycles):
            for j in range(len(texts)):
    #             print "text: " + str(j)
                if j == 0:
                    xtrans[j] = xtrans[j]-20
                    if xtrans[j] < finalX:
                        xtrans[j] = finalX
                    karamba.moveText(widget, texts[j], xtrans[j], startY[j])
    #                 print "xtrans: " + str(xtrans[j])
                if j >= 1:
                    if xtrans[j-1] <= (startX - 40):
                        xtrans[j] = xtrans[j]-20
                        if (xtrans[j]-20) < finalX:
                            xtrans[j] = finalX
                        karamba.moveText(widget, texts[j], xtrans[j], startY[j])
    #                     print "xtrans: " + str(xtrans[j])
            t = float(time.time())
            while (t + animdelay) > float(time.time()):
                pass
            karamba.redrawWidget(widget)
    else:
        for i in range(len(texts)):
            karamba.moveText(widget, texts[i], finalX, startY[i])
        karamba.redrawWidget(widget)

def slideIcons(widget, startX, icons, startY, finalX):
    cycles = ((startX - finalX)/20) + len(icons)
    xtrans = []
    if animate == 0:
        for i in range(len(icons)):
            xtrans.append(startX)
        for i in range(cycles):
            for j in range(len(icons)):
    #             print "text: " + str(j)
                if j == 0:
                    xtrans[j] = xtrans[j]-20
                    if xtrans[j] < finalX:
                        xtrans[j] = finalX
                    karamba.moveImage(widget, icons[j], xtrans[j], startY[j])
    #                 print "xtrans: " + str(xtrans[j])
                if j >= 1:
                    if xtrans[j-1] <= (startX - 40):
                        xtrans[j] = xtrans[j]-20
                        if (xtrans[j]-20) < finalX:
                            xtrans[j] = finalX
                        karamba.moveImage(widget, icons[j], xtrans[j], startY[j])
    #                     print "xtrans: " + str(xtrans[j])
            t = float(time.time())
            while (t + 0.01) > float(time.time()):
                pass
            karamba.redrawWidget(widget)
    else:
        for i in range(len(icons)):
            karamba.moveImage(widget, icons[i], finalX, startY[i])
        karamba.redrawWidget(widget)

def changeToSimple(widget):
    global citysimple
    if moonon == 1:
        showMain(widget, 'complex')
    for i in range(40):
        karamba.moveImage(widget, windpic_bg, (karamba.getImagePos(widget, windpic_bg)[0] + 5), karamba.getImagePos(widget, windpic_bg)[1])
        karamba.moveImage(widget, windpic, (karamba.getImagePos(widget, windpic)[0] + 5), karamba.getImagePos(widget, windpic)[1])
        karamba.moveText(widget, windspeed, (karamba.getTextPos(widget, windspeed)[0] + 5), karamba.getTextPos(widget, windspeed)[1])
        karamba.moveImage(widget, satbutt, karamba.getImagePos(widget, satbutt)[0], karamba.getImagePos(widget, satbutt)[1] - 5)
        karamba.moveImage(widget, cambutt, karamba.getImagePos(widget, cambutt)[0], karamba.getImagePos(widget, cambutt)[1] - 5)
        karamba.moveText(widget, p, karamba.getTextPos(widget, p)[0] + 5, karamba.getTextPos(widget, p)[1])
        karamba.moveText(widget, pnum, karamba.getTextPos(widget, pnum)[0] + 5, karamba.getTextPos(widget, pnum)[1])
        karamba.moveText(widget, h, karamba.getTextPos(widget, h)[0] + 5, karamba.getTextPos(widget, h)[1])
        karamba.moveText(widget, hnum, karamba.getTextPos(widget, hnum)[0] + 5, karamba.getTextPos(widget, hnum)[1])
        karamba.moveText(widget, r, karamba.getTextPos(widget, r)[0] + 5, karamba.getTextPos(widget, r)[1])
        karamba.moveText(widget, rnum, karamba.getTextPos(widget, rnum)[0] + 5, karamba.getTextPos(widget, rnum)[1])
        karamba.moveText(widget, situation, karamba.getTextPos(widget, situation)[0] - 4, karamba.getTextPos(widget, situation)[1])
        karamba.moveText(widget, daytempsrem[0], karamba.getTextPos(widget, daytempsrem[0])[0] - 5, karamba.getTextPos(widget, daytempsrem[0])[1])
        karamba.moveText(widget, daytempsrem[1], karamba.getTextPos(widget, daytempsrem[1])[0] - 5, karamba.getTextPos(widget, daytempsrem[1])[1])
        karamba.moveText(widget, daytempsrem[2], karamba.getTextPos(widget, daytempsrem[2])[0] -5, karamba.getTextPos(widget, daytempsrem[2])[1])
        karamba.moveText(widget, daytempsrem[3], karamba.getTextPos(widget, daytempsrem[3])[0] + 5, karamba.getTextPos(widget, daytempsrem[3])[1])
        karamba.moveText(widget, daytempsrem[4], karamba.getTextPos(widget, daytempsrem[4])[0] + 5, karamba.getTextPos(widget, daytempsrem[4])[1])
#         karamba.moveText(widget, daytextrem[4], karamba.getTextPos(widget, daytextrem[4])[0] + 5, karamba.getTextPos(widget, daytextrem[4])[1])
#         karamba.moveImage(widget, daypicrem[4], karamba.getImagePos(widget, daypicrem[4])[0] + 5, karamba.getImagePos(widget, daypicrem[4])[1])
        karamba.redrawWidget(widget)

    karamba.redrawWidget(widget)
    karamba.resizeText(widget, maintemp, 100, 50)
#    karamba.changeTextFont(widget, maintemp, 'arial')
    size = 20
    citysimple = karamba.createText(widget, 260, 85, 110, 20, weather.place())
    prettyText(widget, fontSizeMatrix[1], fontFamilyMatrix[1], shadow, citysimple)
    ratio = []
    for i in range(5):
        daypicw = karamba.getImageWidth(widget,daypicrem[i])
        daypich = karamba.getImageHeight(widget,daypicrem[i])
        daypicratio = daypicw / daypich
        ratio.append(daypicratio)
        karamba.setImagePath(widget, daypicrem[i], iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons', 'large_icons'))
        karamba.resizeImage(widget, daypicrem[i], daypicw, daypich)
    for i in range(10):
#        print i
        size = size + 2
        karamba.changeTextSize(widget, maintemp, size)
        karamba.moveText(widget, maintemp, karamba.getTextPos(widget, maintemp)[0] - 1, karamba.getTextPos(widget, maintemp)[1])
        karamba.moveText(widget, citysimple, karamba.getTextPos(widget, citysimple)[0] - 15, karamba.getTextPos(widget, citysimple)[1])
        for i in range(5):
            karamba.resizeImage(widget, daypicrem[i], karamba.getImageSize(widget, daypicrem[i])[0] + 1, karamba.getImageSize(widget, daypicrem[i])[1] + 1)
            karamba.moveImage(widget, daypicrem[i], karamba.getImagePos(widget, daypicrem[i])[0] - 1, karamba.getImagePos(widget, daypicrem[i])[1])
        karamba.redrawWidget(widget)
    for i in range(5):
        karamba.resizeImage(widget, daypicrem[i], karamba.getImageWidth(widget,daypicrem[i]), karamba.getImageHeight(widget,daypicrem[i]) * ratio[i])
    karamba.redrawWidget(widget)
    karamba.addImageTooltip(widget, mainpic, situtext)
    karamba.addImageTooltip(widget, satbutt, ' ')
    karamba.addImageTooltip(widget, cambutt, ' ')
    deletimage = [windpic_bg, windpic, satbutt, cambutt, tooltipp, tooltipr, tooltiph]
    for i in range(len(deletimage)):
        karamba.deleteImage(widget, deletimage[i])
    deletext =[p, h, r, pnum, hnum, rnum, windspeed, situation]
    for i in range(len(deletext)):
        karamba.deleteText(widget, deletext[i])
    for i in range(5):
        karamba.deleteText(widget, daytempsrem[i])
    karamba.redrawWidget(widget)
def changeToComplex(widget):
    global stormon, situation, satbutt, cambutt, stormbutt, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, windpic, windspeed, mainpic, windpic, h, p, r, windpic_bg, tooltiph, tooltipp, tooltipr, base_menuime
    if moonon == 1:
        showMain(widget, 'simple')
    for i in range(26):
        karamba.translateAll(widget, -10, 0)
        karamba.redrawWidget(widget)
    karamba.deleteText(widget, maintemp)
    karamba.deleteText(widget, citysimple)
    karamba.deleteImage(widget, mainpic)
    for i in range(5):
        karamba.deleteText(widget, daytextrem[i])
        karamba.deleteImage(widget, daypicrem[i])
    karamba.translateAll(widget, 260, 0)
    if flatflag == 1:
        windpic_bg = karamba.createImage(widget, 180, 62, 'wind_icons/flat/wind_bg.png')
    else:
        windpic_bg = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/wind_bg.png')
    #layout text
    p = karamba.createText(widget, 120, 58, 15, 12, "P:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, p)
    tooltipp = karamba.createImage(widget, 120, 58, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipp, _('Air Pressure'))
    h = karamba.createText(widget, 120, 70, 15, 12, "H:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, h)
    tooltiph = karamba.createImage(widget, 120, 70, "tooltip.png")
    karamba.addImageTooltip(widget, tooltiph, _('Humidity'))
    r = karamba.createText(widget, 120, 82, 15, 12, "R:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, r)
    tooltipr = karamba.createImage(widget, 120, 82, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipr, _('Relative Temp After Windchill'))
    maintemp = karamba.createText(widget, 120, 33, 59, 30, weather.temperature())
    prettyText(widget, fontSizeMatrix[0], fontFamilyMatrix[0], shadow, maintemp)
    karamba.attachClickArea(widget, maintemp)
    situtext = _(weather.sky())
    if situtext == None:
        situtext = weather.sky()
        transError(widget, weather.sky())
    situation = karamba.createText(widget, 37, 104, 200, 18, weather.place())
    prettyText(widget, fontSizeMatrix[1], fontFamilyMatrix[1], shadow, situation)

    mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
    karamba.attachClickArea(widget, mainpic)
    karamba.addImageTooltip(widget, mainpic, situtext)
    pnum = karamba.createText(widget, 135, 58, 75, 12, weather.pressure())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, pnum)
    hnum = karamba.createText(widget, 135, 70, 30, 12, weather.humidity())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hnum)
    rnum = karamba.createText(widget, 135, 82, 30, 12, weather.relative_heat())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, rnum)
    windicon = weather.wind_icon_path()
    if flatflag == 1:
        windspeed = karamba.createText(widget, 182, 107, 40, 15, weather.wind_speed())
    else:
        windspeed = karamba.createText(widget, 182, 94, 40, 15, weather.wind_speed())
    prettyText(widget, fontSizeMatrix[2] - 1, fontFamilyMatrix[2], shadow, windspeed)
    if flatflag == 1:
        windpic = karamba.createImage(widget, 180, 62, 'wind_icons/flat/' + windicon)
    else:
        windpic = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/' + windicon)

    xstart = 37
    daytextrem = []
    daytempsrem = []
    daypicrem = []
    daypicpos = []
    base_menuime = int(weather.time()[:2])
    for i in range(0,5):
        #if i == 0:
        #    if base_menuime >= 14:
        #        sep = weather.get_forecast(i).temp_range().find('/')
        #       daytext = karamba.createText(widget, xstart, 125, 40, 12, "2nite:")
        #        daytemps = karamba.createText(widget, xstart, 168, 40, 12, "Lo:" + weather.get_forecast(i).temp_range()[:sep])
        #    else:
        #        daytext = karamba.createText(widget, xstart, 125, 40, 12, "2day:")
        #        daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        #else:
        daytext = karamba.createText(widget, xstart, 125, 40, 12, _(weather.get_forecast(i).weekday()) + ":")
        daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytext)
        daytextrem.append(daytext)

        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytemps)
        daytempsrem.append(daytemps)
        daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path())
        karamba.attachClickArea(widget, daypic)
        if (i == 0) and (use_wcom == 1):
            karamba.addImageTooltip(widget,daypic,_("Left click shows today's forecast - Middle click for hourly forecast"))
        daypicrem.append(daypic)
        daypicpos.append(xstart + 5)
        xstart = xstart + 39
    satbutt = karamba.createImage(widget, 179, 36, 'satbutton' + flatstring + '.png')
    karamba.attachClickArea(widget, satbutt)
    karamba.addImageTooltip(widget, satbutt, _('Weather Maps'))
    cambutt = karamba.createImage(widget, 203, 36, 'webcambutton' + flatstring + '.png')
    karamba.attachClickArea(widget, cambutt)
    karamba.addImageTooltip(widget, cambutt, _('Webcams'))
    if stormFlag == 1:
        stormon = 1
        karamba.deleteImage(widget, satbutt)
        karamba.redrawWidget(widget)
        stormbutt = karamba.createImage(widget, 179, 36, 'storm.png')
        karamba.attachClickArea(widget, stormbutt)
        karamba.redrawWidget(widget)
    karamba.translateAll(widget, -260, 0)
    karamba.redrawWidget(widget)
    karamba.redrawWidgetBackground(widget)
    for i in range(26):
        karamba.translateAll(widget, 10, 0)
        karamba.redrawWidget(widget)

def writeGuiConfig(widget):
    global cities, codes
    from ConfigParser import RawConfigParser
    config = RawConfigParser()
    config.add_section('Main')
    config.add_section('WebcamLabels')
    config.add_section('WebcamURLs')
    config.add_section('Fonts')

    # DAVE
    if len(cities) == 0:
        cities.append('Wellington, New Zealand')
        codes.append('NZXX0049')
    config.add_section('Locations')
    i = 1
    for city in cities:
        config.set('Locations','city'+str(i),city)
        config.set('Locations','code'+str(i),codes[i-1])
        i = i + 1
    config.set('Main','change_flag',1)
    
    
    config.set('Fonts','temp_family',fontFamilyMatrix[0])
    config.set('Fonts','temp_size',str(fontSizeMatrix[0]))
    config.set('Fonts','sky_family',fontFamilyMatrix[1])
    config.set('Fonts','sky_size',str(fontSizeMatrix[1]))
    config.set('Fonts','detail_family',fontFamilyMatrix[2])
    config.set('Fonts','detail_size',str(fontSizeMatrix[2]))
    config.set('Fonts','panel_family',fontFamilyMatrix[3])
    config.set('Fonts','panel_size',str(fontSizeMatrix[3]))
    config.set('Fonts','hour_family',fontFamilyMatrix[4])
    config.set('Fonts','hour_size',str(fontSizeMatrix[4]))
    config.set('Main','trans_change',str(0))
    config.set('Main','metric',str(metric_units))
    config.set('Main','24hour',str(clock))
    config.set('Main','update',str(delay))
    config.set('Main','threading',str(threadflag))
    config.set('Main','kxdocker',str(kxdocker))
    config.set('Main','dnamobst',str(dnamobst))
    config.set('Main','connection',str(connect_warn))
    config.set('Main','wind',str(windy))
    config.set('Main','animation',str(animate))
    config.set('Main','animstyle',str(animstyle))
    if haveiconpath == 1:
        config.set('Main','icondir',alticonsetpath)
    else:
        config.set('Main','icondir','NoDir')
    config.set('Main','iconset',iconset)
    if havebkgdpath == 1:
        config.set('Main','bkgd_dir',altbkgdpath)
    else:
        config.set('Main','bkgd_dir','NoDir')
    config.set('Main','bkgd_set',bkgd_set)
    config.set('Main','mainback',mainback)
    config.set('Main','shadow',str(shadow))
    #if font_range == 'verdana':
        #config.set('Main','font_range',str(0))
    #else:
        #config.set('Main','font_range',str(1))
    if use_wcom == 1:
        config.set('Main','code',str(wcomcode))
    else:
        config.set('Main','code',str(bbc_code))
    config.set('Main','main_red',str(red))
    config.set('Main','main_green',str(green))
    config.set('Main','main_blue',str(blue))
    config.set('Main','panel_red',str(reddrop))
    config.set('Main','panel_green',str(greendrop))
    config.set('Main','panel_blue',str(bluedrop))
    config.set('Main','city',weather.place())
    if language == '':
        config.set('Main','translation','None')
    else:
        config.set('Main','translation',language)
    config.set('Main','text_animstyle',textstyle)
    config.set('Main','animdelay',str(animdelay * 100))
    for i in range(len(webcamlabels)):
        config.set('WebcamLabels','wclabel' + str(i), webcamlabels[i])
        config.set('WebcamURLs','wcurls' + str(i), webcamurls[i])
    config_file = open(config_directory + '/lwp_gui_config', 'w')
    config.write(config_file)
    config_file.close()

def getGuiConfig(widget):
    global metric_units, clock, delay, threadflag, kxdocker, dnamobst, windy, webcamlabels, webcamurls, animate, animstyle, shadow, font_range, red, green, blue, reddrop, greendrop, bluedrop, iconset, mainback, alticonsetpath, haveiconpath, configchange, iconsetpath, background, altback, webcamdisplay, nowebcams, url, use_wcom, wcomcode, bbc_code, windpic_bg, firsttime, language, textstyle, animdelay, bg, ddcbg, ddbg, hbg, hbg2, bkgd_set, bkgd_dir, havebkgdpath, altbkgdpath, set_gui_failed, change_flag, gui_on, fontFamilyMatrix, fontSizeMatrix, cities, codes, connect_warn
    print "Reading from Config ..."
    webcamlabels = []
    webcamurls = []
    from ConfigParser import RawConfigParser
    #try:
    config = RawConfigParser()
    config.read(config_directory + '/lwp_gui_config')
    try:
        if (config.getint('Main','change_flag') == 3) and (gui_on != 1):
            config_file = open(config_directory + '/lwp_gui_config','w')
            config.set('Main','change_flag',str(1))
            config.write(config_file)
            config_file.close()
            karamba.reloadTheme(widget)
    except:
        pass
    try:
        change_flag = config.getint('Main','change_flag')
    except:
        pass
    try:
        connect_warn = config.getint('Main','connection')
    except:
        pass
    try:
        fontFamilyMatrix = [config.get('Fonts','temp_family'),config.get('Fonts','sky_family'),config.get('Fonts','detail_family'),config.get('Fonts','panel_family'),config.get('Fonts','hour_family')]
        fontSizeMatrix = [config.getint('Fonts','temp_size'),config.getint('Fonts','sky_size'),config.getint('Fonts','detail_size'),config.getint('Fonts','panel_size'),config.getint('Fonts','hour_size')]
    except:
        pass

    # DAVE
    cities = []
    codes = []

    locations = config.items('Locations')
    numLocs = len(locations) / 2
    for i in range(1,numLocs+1):
        cityOpt = 'city' + str(i)
        codeOpt = 'code' + str(i)
        cityName = config.get('Locations',cityOpt)
        codeVal = config.get('Locations',codeOpt)
        cities.append(cityName)
        codes.append(codeVal)
    
    
    metric_units = config.getint('Main','metric')
    clock = config.getint('Main','24hour')
    delay = config.getint('Main','update')
    kxdocker = config.getint('Main','kxdocker')
    dnamobst = config.getint('Main','dnamobst')
    windy = config.getint('Main','wind')
    animate = config.getint('Main','animation')
    animstyle = config.getint('Main','animstyle')
    if config.get('Main','icondir') != 'NoDir':
        alticonsetpath = config.get('Main','icondir')
        haveiconpath = 1
    iconset = config.get('Main','iconset')
    if (iconset == 'Liquid') or (iconset == 'Umicons'):
        iconsetpath = 'icons/' + iconset + '/'
    else:
        iconsetpath = alticonsetpath + '/' + iconset + '/'
    mainback = config.get('Main','mainback')
    shadow = config.getint('Main','shadow')
    #if config.getint('Main','font_range') == 0:
        #font_range = 'verdana'
    #else:
        #font_range = 'arial narrow'
    code = config.get('Main','code')
    if len(code) < 5:
        url = url= url_bbc_base_addr + code + url_bbc_add_addr
        use_wcom = 0
        bbc_code = code
    else:
        url = url_base_addr + code + url_suffix
        use_wcom = 1
        wcomcode = code
    red = config.getint('Main','main_red')
    green = config.getint('Main','main_green')
    blue = config.getint('Main','main_blue')
    reddrop = config.getint('Main','panel_red')
    greendrop = config.getint('Main','panel_green')
    bluedrop = config.getint('Main','panel_blue')
    if config.get('Main','translation') == 'None':
        language = ''
    else:
        language = config.get('Main','translation')
    try:
        textstyle = config.getint('Main','text_animstyle')
    except:
        pass
    try:
        anim_delay = (config.getint('Main','animdelay')/100)
    except:
        pass
    try:
        if config.get('Main','bkgd_dir') != 'NoDir':
            altbkgdpath = config.get('Main','bkgd_dir')
            havebkgdpath = 1
    except:
            pass
    try:
        bkgd_set = config.get('Main','bkgd_set')
    except:
        pass
    if base_bkgd.count(bkgd_set) > 0:
        theme_file = open(config_directory + '/theme_path','r')
        theme_path = theme_file.readlines()
        theme_file.close()
        for i in range(len(theme_path)):
            theme_path[i] = theme_path[i].replace('\n','')
        if theme_path[1] == '0':
            bg_tmpf = open(theme_path[0] + 'background/' + bkgd_set + '/bg.png','r')
            dd_bg_tmpf = open(theme_path[0] + 'background/' + bkgd_set + '/dd_bg.png','r')
            ddc_bg_tmpf = open(theme_path[0] + 'background/' + bkgd_set + '/ddc_bg.png','r')
            hbg_tmpf = open(theme_path[0] + 'background/' + bkgd_set + '/hbg.png','r')
            bg_tmp = bg_tmpf.read()
            dd_bg_tmp = dd_bg_tmpf.read()
            ddc_bg_tmp = ddc_bg_tmpf.read()
            hbg_tmp = hbg_tmpf.read()

        else:
            zip_file = zipfile.ZipFile(theme_path[0])
            bg_tmp = zip_file.read('background/' + bkgd_set + '/bg.png')
            dd_bg_tmp = zip_file.read('background/' + bkgd_set + '/dd_bg.png')
            ddc_bg_tmp = zip_file.read('background/' + bkgd_set + '/ddc_bg.png')
            hbg_tmp = zip_file.read('background/' + bkgd_set + '/hbg.png')

        try:
            os.mknod(config_directory + '/background/bg.png')
            os.mknod(config_directory + '/background/dd_bg.png')
            os.mknod(config_directory + '/background/ddc_bg.png')
            os.mknod(config_directory + '/background/hbg.png')
        except(OSError):
            pass
        bg_file = open(config_directory + '/background/bg.png','w')
        dd_bg_file = open(config_directory + '/background/dd_bg.png','w')
        ddc_bg_file = open(config_directory + '/background/ddc_bg.png','w')
        hbg_file = open(config_directory + '/background/hbg.png','w')
        print >> bg_file, bg_tmp
        print >> dd_bg_file, dd_bg_tmp
        print >> ddc_bg_file, ddc_bg_tmp
        print >> hbg_file, hbg_tmp
        bg_file.close()
        dd_bg_file.close()
        ddc_bg_file.close()
        hbg_file.close()
    else:
        theme_file = open(config_directory + '/theme_path','r')
        theme_path = theme_file.readlines()
        theme_file.close()
        for i in range(len(theme_path)):
            theme_path[i] = theme_path[i].replace('\n','')
        try:
            os.mknod(config_directory + '/background/bg.png')
            os.mknod(config_directory + '/background/dd_bg.png')
            os.mknod(config_directory + '/background/ddc_bg.png')
            os.mknod(config_directory + '/background/hbg.png')
        except(OSError):
            pass
        bg_file = open(config_directory + '/background/bg.png','w')
        dd_bg_file = open(config_directory + '/background/dd_bg.png','w')
        ddc_bg_file = open(config_directory + '/background/ddc_bg.png','w')
        hbg_file = open(config_directory + '/background/hbg.png','w')
        if theme_path[1] == '0':
            dd_bg_tmpd = open(theme_path[0] + 'background/dd_bg.png','r')
            ddc_bg_tmpd = open(theme_path[0] + 'background/ddc_bg.png','r')
            hbg_tmpd = open(theme_path[0] + 'background/hbg.png','r')
            dd_bg_tmpf = dd_bg_tmpd.read()
            ddc_bg_tmpf = ddc_bg_tmpd.read()
            hbg_tmpf = hbg_tmpd.read()
            print >> dd_bg_file, dd_bg_tmpf
            print >> ddc_bg_file, ddc_bg_tmpf
            print >> hbg_file, hbg_tmpf
        else:
            zip_file = zipfile.ZipFile(theme_path[0])
            dd_bg_tmpf = zip_file.read('background/dd_bg.png')
            ddc_bg_tmpf = zip_file.read('background/ddc_bg.png')
            hbg_tmpf = zip_file.read('background/hbg.png')
            print >> dd_bg_file, dd_bg_tmpf
            print >> ddc_bg_file, ddc_bg_tmpf
            print >> hbg_file, hbg_tmpf
        dd_bg_file.close()
        ddc_bg_file.close()
        hbg_file.close()
        dd_bg_file = open(config_directory + '/background/dd_bg.png','w')
        ddc_bg_file = open(config_directory + '/background/ddc_bg.png','w')
        hbg_file = open(config_directory + '/background/hbg.png','w')
        print altbkgdpath + '/' + bkgd_set + '/bg.png'
        bg_tmpd = open(altbkgdpath + '/' + bkgd_set + '/bg.png', 'r')
        bg_tmpf = bg_tmpd.read()
        print >> bg_file, bg_tmpf
        bg_file.close()
        try:
            dd_bg_tmpd = open(altbkgdpath + '/' + bkgd_set + '/dd_bg.png', 'r')
            dd_bg_tmpf = dd_bg_tmpd.read()
            print >> dd_bg_file, dd_bg_tmpf
            dd_bg_file.close()
        except:
            pass
        try:
            ddc_bg_tmpd = open(altbkgdpath + '/' + bkgd_set + '/ddc_bg.png','r')
            ddc_bg_tmpf = ddc_bg_tmpd.read()
            print >> ddc_bg_file, ddc_bg_tmpf
            ddc_bg_file.close()
        except:
            pass
        try:
            hbg_tmpd = open(altbkgdpath + '/' + bkgd_set + '/hbg.png','r')
            hbg_tmpf = hbg_tmpd.read()
            print >> hbg_file, hbg_tmpf
            hbg_file.close()
        except:
            pass
    labels = config.options('WebcamLabels')
    urls = config.options('WebcamURLs')
    webcamlabels = []
    webcamurls = []
    for i in range(len(labels)):
        webcamlabels.append(config.get('WebcamLabels','wclabel' + str(i)))
        webcamurls.append(config.get('WebcamURLs','wcurls' + str(i)))
    bg = config_directory + '/background/bg.png'
    ddbg = config_directory + '/background/dd_bg.png'
    ddcbg = config_directory + '/background/ddc_bg.png'
    hbg = config_directory + '/background/hbg.png'
    hbg2 = config_directory + '/background/hbg.png'
    set_gui_failed = 0

def showMoon(widget, moon_ui):
    global mainpic, moonon
    karamba.deleteImage(widget, mainpic)
    for i in range(9,0,-1):
        mainpic = karamba.createImage(widget, 0, 0, config_directory + '/fade/main_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, mainpic)
        time.sleep(0.04)
    if moon_ui == 'complex':
        karamba.changeText(widget, situation, _(moon_phase))
    for i in range(10):
        mainpic = karamba.createImage(widget, 0, 0, config_directory + '/fade/moon_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, mainpic)
        time.sleep(0.04)
    mainpic = karamba.createImage(widget, 0, 0, config_directory + '/fade/moon.png')
    karamba.attachClickArea(widget, mainpic)
    if moon_ui == 'simple':
        karamba.addImageTooltip(widget, mainpic, _(moon_phase))
    moonon = 1

def showMain(widget, moon_ui):
    global mainpic, moonon
    karamba.deleteImage(widget, mainpic)
    for i in range(9,0,-1):
        mainpic = karamba.createImage(widget, 0, 0, config_directory + '/fade/moon_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, mainpic)
        time.sleep(0.04)
    if moon_ui == 'complex':
        karamba.changeText(widget, situation, weather.place())
    for i in range(10):
        mainpic = karamba.createImage(widget, 0, 0, config_directory + '/fade/main_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        karamba.deleteImage(widget, mainpic)
        time.sleep(0.04)
    mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
    karamba.attachClickArea(widget, mainpic)
    karamba.addImageTooltip(widget, mainpic, situtext)
    moonon = 0

def fadeInSplash(widget):
    global splash
    for i in range(10):
        splash = karamba.createImage(widget,0,0,'splash/splash_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        time.sleep(0.04)
        karamba.deleteImage(widget,splash)
    splash = karamba.createImage(widget,0,0,'splash/splash.png')
    karamba.redrawWidget(widget)

def fadeOutSplash(widget):
    global splash
    karamba.deleteImage(widget,splash)
    for i in range(9,0,-1):
        splash = karamba.createImage(widget,0,0,'splash/splash_alpha_' + str(i) + '.png')
        karamba.redrawWidget(widget)
        time.sleep(0.04)
        karamba.deleteImage(widget,splash)
    karamba.redrawWidget(widget)

def showLoading(widget):
    global loading
    loading = karamba.createText(widget, 80, 100, 120, 30, _('resetting theme ...'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, loading)
    karamba.redrawWidget(widget)

def resetWidget(widget):
    global situtext, stormFlag, stormon, stormbutt, weather, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, situation, wind_speed, mainpic, daytext, daytemps, daypics, windpic, windpic_bg, buttonpressed, background, timegate, configchange, firsttime, clicky, daypicpos, windspeed, werethreading, satbutt, cambutt, windpic_bg, flatflag, windspeed, kxdocker_running, kxdocker_lasttime, kxdocker, base_menuime
    
    loadingon = 0
    spinner = 0
    karamba.redrawWidgetBackground(widget)

    for i in range(26):
            karamba.translateAll(widget, -10, 0)
            karamba.redrawWidget(widget)


    showLoading(widget)
    karamba.redrawWidget(widget)
    loadingon = 1
    testkxd = os.popen('dcop kxdocker').readlines()
    if len(testkxd) > 1:
        kxdocker_running = 1
    if kxdocker_running == 1:
        if (kxdocker == 1) and (kxdocker_lasttime == 1):
            os.system('dcop kxdocker docker setOverlayImageByName Current 0 0 spin_waiting')
            spinner = 1
            
    getGuiConfig(widget)
    weather.metric(metric_units)
    weather.reverse_wind_arrows(windy)

    if use_wcom == 1:
        globals()["mnfThread"] = fadeMoon(widget)
        globals()["mnfThread"].start()


    karamba.translateAll(widget, 260, 0)
    if animstyle == 2:
        globals()["bgfThread"] = fadeBG(widget)
        globals()["bgfThread"].start()

    if UI == 'complex':
        karamba.deleteImage(widget, windpic_bg)
    karamba.deleteImage(widget, background)
    background = karamba.createBackgroundImage(widget, 15, 15, bg)
    if UI == 'complex':
        if flatflag == 1:
            windpic_bg = karamba.createImage(widget, 180, 62, "wind_icons/flat/wind_bg.png")
        else:
            windpic_bg = karamba.createImage(widget, 192, 70, "wind_icons/liquid/wind_bg.png")

    if UI == 'complex':
        karamba.changeText(widget, maintemp, weather.temperature())
        prettyText(widget, fontSizeMatrix[0], fontFamilyMatrix[0], shadow, maintemp)
        situtext = _(weather.sky())
        if situtext == None:
            situtext = weather.sky()
            transError(widget, weather.sky())
        karamba.changeText(widget, situation, weather.place())
        prettyText(widget, fontSizeMatrix[1], fontFamilyMatrix[1], shadow, situation)
        karamba.deleteText(widget, windspeed)
        if flatflag == 1:
            windspeed = karamba.createText(widget, 182, 107, 40, 15, weather.wind_speed())
        else:
            windspeed = karamba.createText(widget, 182, 94, 40, 15, weather.wind_speed())
        prettyText(widget, fontSizeMatrix[2] - 1, fontFamilyMatrix[2], shadow, windspeed)
        karamba.deleteImage(widget, mainpic)
        if stormon == 0:
            karamba.deleteImage(widget, satbutt)
        karamba.deleteImage(widget, cambutt)
        karamba.deleteImage(widget, windpic_bg)
        if stormon == 1:
            karamba.deleteImage(widget, stormbutt)
            stormon = 0
        satbutt = karamba.createImage(widget, 179, 36, 'satbutton' + flatstring + '.png')
        karamba.attachClickArea(widget, satbutt)
        karamba.addImageTooltip(widget, satbutt, _('Weather Maps'))
        cambutt = karamba.createImage(widget, 203, 36, 'webcambutton' + flatstring + '.png')
        karamba.attachClickArea(widget, cambutt)
        karamba.addImageTooltip(widget, cambutt, _('Webcams'))
        if flatflag == 1:
            windpic_bg = karamba.createImage(widget, 180, 62, 'wind_icons/flat/wind_bg.png')
        else:
            windpic_bg = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/wind_bg.png')
        mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
        karamba.attachClickArea(widget, mainpic)
        karamba.addImageTooltip(widget, mainpic, situtext)
        windicon = weather.wind_icon_path()
        karamba.deleteImage(widget, windpic)
    #     karamba.redrawWidget(widget)
    #     karamba.redrawWidgetBackground(widget)
        if flatflag == 1:
            windpic = karamba.createImage(widget, 180, 62, 'wind_icons/flat/' + windicon)
        else:
            windpic = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/' + windicon)
    #     karamba.redrawWidget(widget)
        xstart = 37
        base_menuime = int(weather.time()[:2])
        for i in range(0,5):
            if i == 0:
                if base_menuime >= 14:
                    sep = weather.get_forecast(i).temp_range().find('/')
                    karamba.changeText(widget, daytextrem[i], _('2nite') + ':')
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
                    karamba.changeText(widget, daytempsrem[i], "Lo:" + weather.get_forecast(i).temp_range()[:sep])
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytempsrem[i])
                else:
                    karamba.changeText(widget, daytextrem[i], _('2day') + ':')
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
                    karamba.changeText(widget, daytempsrem[i], weather.get_forecast(i).temp_range())
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytempsrem[i])
            else:
                karamba.changeText(widget, daytextrem[i], _(weather.get_forecast(i).weekday()) + ":")
                prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
                karamba.changeText(widget, daytempsrem[i], weather.get_forecast(i).temp_range())
                prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytempsrem[i])
            #karamba.redrawWidget(widget)
            karamba.deleteImage(widget, daypicrem[i])
            daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path())
            karamba.attachClickArea(widget, daypic)
            if (i == 0) and (use_wcom == 1):
                karamba.addImageTooltip(widget,daypic,_("Left click shows today's forecast - Middle click for hourly forecast"))

    #         karamba.redrawWidget(widget)
            daypicrem[i] = daypic
            daypicpos[i] = (xstart + 5)
            xstart +=  39
        karamba.changeText(widget, pnum, weather.pressure())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, pnum)
        karamba.changeText(widget, hnum, weather.humidity())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hnum)
        karamba.changeText(widget, rnum, weather.relative_heat())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, rnum)
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, p)
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, r)
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, h)
        if (stormFlag == 1):
            stormon = 1
            karamba.deleteImage(widget, satbutt)
    #         karamba.redrawWidget(widget)
            stormbutt = karamba.createImage(widget, 179, 36, 'storm.png')
            karamba.attachClickArea(widget, stormbutt)
    #         karamba.redrawWidget(widget)
        #karamba.changeText(widget, wind_speed, today[9])
    else:
        situtext = _(weather.sky())
        if situtext == None:
            situtext = weather.sky()
            transError(widget, weather.sky())
        karamba.changeText(widget, maintemp, weather.temperature())
        prettyText(widget, 40, fontFamilyMatrix[0], shadow, maintemp)
        karamba.changeText(widget, citysimple, weather.place())
        prettyText(widget, fontSizeMatrix[1], fontFamilyMatrix[1], shadow, citysimple)
        karamba.deleteImage(widget, mainpic)
        mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
        karamba.attachClickArea(widget, mainpic)
        karamba.addImageTooltip(widget, mainpic, situtext)
        xstart = 27
        base_menuime = int(weather.time()[:2])
        for i in range(0,5):
            if i == 0:
                if base_menuime >= 14:
                    karamba.changeText(widget, daytextrem[i], _('2nite') + ':')
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
                else:
                    karamba.changeText(widget, daytextrem[i], _('2day') + ':')
                    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
            else:
                karamba.changeText(widget, daytextrem[i], _(weather.get_forecast(i).weekday()) + ":")
                prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytextrem[i])
            #karamba.redrawWidget(widget)
            karamba.deleteImage(widget, daypicrem[i])
            daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons','large_icons'))
            karamba.resizeImage(widget, daypic, 38, 38)
            karamba.attachClickArea(widget, daypic)
            if (i == 0) and (use_wcom == 1):
                karamba.addImageTooltip(widget,daypic,_("Left click shows today's forecast - Middle click for hourly forecast"))
    #         karamba.redrawWidget(widget)
            daypicrem[i] = daypic
            daypicpos[i] = (xstart + 5)
            xstart +=  39

    testkxd = os.popen('dcop kxdocker').readlines()
    if len(testkxd) > 1:
        kxdocker_running = 1
    if kxdocker_running == 1:
        if (iconset == 'Liquid') or (iconset == 'Umicons'):
            curricon = karamba.readThemeFile(widget, iconsetpath + weather.icon_path())
        else:
            curricon = open(iconsetpath + weather.icon_path(),'r')
            curricon = curricon.read()
        icon_file = open(config_directory + '/kxdico_curr','w')
        print >> icon_file, curricon
        icon_file.close()
        for i in range(5):
            if (iconset == 'Liquid') or (iconset == 'Umicons'):
                icon_img = karamba.readThemeFile(widget, iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons', 'large_icons'))
            else:
                curricon = open(iconsetpath + weather.get_forecast(i).icon_path().replace('small_icons', 'large_icons'),'r')
                icon_img = curricon.read()
            icon_file = open(config_directory + '/kxdico_' + str(i),'w')
            print >> icon_file, icon_img
            icon_file.close()
        if (kxdocker == 1) and (kxdocker_lasttime == 1):
            globals()["kxdThread"] = changeKxdocker(widget)
            globals()["kxdThread"].start()
            kxdocker_lasttime = 1
        elif (kxdocker == 1) and (kxdocker_lasttime == 0):
            globals()["kxdThread"] = initKxdocker(widget)
            globals()["kxdThread"].start()
            kxdocker_lasttime = 1
        elif (kxdocker == 0) and (kxdocker_lasttime == 1):
            os.system('dcop kxdocker docker removeByName Current')
            os.system('dcop kxdocker docker removeByName For1')
            os.system('dcop kxdocker docker removeByName For2')
            os.system('dcop kxdocker docker removeByName For3')
            os.system('dcop kxdocker docker removeByName For4')
            os.system('dcop kxdocker docker removeByName For5')
            kxdocker_lasttime = 0
    karamba.translateAll(widget, -260, 0)
    karamba.redrawWidget(widget)
    karamba.redrawWidgetBackground(widget)
    for i in range(26):
        karamba.translateAll(widget, 10, 0)
        karamba.redrawWidget(widget)
    if loadingon == 1:
        karamba.deleteText(widget, loading)
    if spinner == 1:
        os.system('dcop kxdocker docker setOverlayImageByName Current 0 0 ""')
    print '>>>>>>>>>>>>>>>>>>>>> Widget Reset <<<<<<<<<<<<<<<<<<<<<<<<'

def createConfigMenu(widget):
    karamba.addMenuConfigOption(widget, "config_gui", _('Configure theme'))
    karamba.setMenuConfigOption(widget, "config_gui", 0)
    karamba.addMenuConfigOption(widget, "separator", '---------------------')
    karamba.setMenuConfigOption(widget, "separator", 0)
    for i in range(len(cities)):
        entryName = 'entry' + str(i)
        karamba.addMenuConfigOption(widget, entryName, cities[i])
        karamba.setMenuConfigOption(widget, entryName, 0)
        if use_wcom == 1:
            if wcomcode == codes[i]:
                karamba.setMenuConfigOption(widget, entryName, 1)
        else:
            if bbc_code == codes[i]:
                karamba.setMenuConfigOption(widget, entryName, 1)
    karamba.addMenuConfigOption(widget, "separator1", '---------------------')
    karamba.setMenuConfigOption(widget, "separator1", 0)
    karamba.addMenuConfigOption(widget, "help", _('Get help'))
    karamba.setMenuConfigOption(widget, "help", 0)
    karamba.addMenuConfigOption(widget, "about", _('About Liquid Weather ++'))
    karamba.setMenuConfigOption(widget, "about", 0)
    
def showAbout(widget):
    global abouton,abname,abversion,abauthor,ablicense,abweb,dabversion,dabauthor,dablicense,dabweb,dropdownflag, animpanel
    if animstyle == 0:
        dropDownEngine(widget, mainpic, ddcbg, 20, 196, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), 0, 0, 10, 140, 13, 136, 196, 36, 36, 33, 25, 0)
    
    elif animstyle == 1:
        expandEngine(widget, mainpic, ddcbg, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), 0, 0, 8, 10, 126, 89, 9, 6, 13, 19, 33, 25, 196, 136, 36, 36, 0)
    
    elif animstyle == 2:
        fadeInEngine(widget, mainpic, ddcbg, karamba.getImageHeight(widget, mainpic), karamba.getImageWidth(widget, mainpic), "ddcbg_alpha_", 33, 25, 196, 136, 0, 0, 0)
    else:
        animpanel = karamba.createImage(widget,33,25,ddcbg)
        karamba.redrawWidget(widget)
    karamba.redrawWidget(widget)
    abname = karamba.createText(widget, 70, 33, 200, 20, _('liquid weather ++'))
    prettyText(widget, fontSizeMatrix[3], fontFamilyMatrix[3], shadow, abname)
    abversion = karamba.createText(widget, 50, 57, 70, 20, _('Version:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, abversion)
    abauthor = karamba.createText(widget, 50, 77, 70, 20, _('Author:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, abauthor)
    ablicense = karamba.createText(widget, 50, 97, 70, 20, _('License:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, ablicense)
    abweb = karamba.createText(widget, 50, 117, 70, 20, _('Website:'))
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, abweb)
    dabversion = karamba.createText(widget, 100, 57, 120, 20, version)
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, dabversion)
    dabauthor = karamba.createText(widget, 100, 77, 120, 20, "dmbkiwi@yahoo.com")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, dabauthor)
    dablicense = karamba.createText(widget, 100, 97, 120, 20, "GPL v2")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, dablicense)
    dabweb = karamba.createRichText(widget, '<a href="konqueror http://liquidweather.net">liquidweather.net</a>',1)
    karamba.moveRichText(widget,dabweb,100,114)
    karamba.changeRichTextSize(widget,dabweb,fontSizeMatrix[2])
    karamba.changeRichTextFont(widget,dabweb,fontFamilyMatrix[2])
    karamba.showRichText(widget,dabweb)
    karamba.redrawWidget(widget)
    abouton = 1
    dropdownflag = 0
    
def deleteAbout(widget):
    global abouton, otherdetail
    texttodelete=[abname,abversion,abauthor,ablicense,abweb,dabversion,dabauthor,dablicense]
    for i in texttodelete:
        karamba.deleteText(widget,i)
    karamba.deleteRichText(widget,dabweb)
    karamba.redrawWidget(widget)
    if animstyle == 0:
        rollUpEngine(widget, mainpic, animpanel, 0, 196, 120, 120, 0, 0, 136, 10, -13, -36, 36, 0)
    #karamba.deleteImage(widget, ddcbg)
    #widget, icon, panel, hIcon, wIcon, hPanel, wPanel, xPanel, yPanel, xPanelInc, yPanelInc, hPanelInc, wPanelInc, xFinal, yFinal, hFinal, wFinal
    elif animstyle == 1:
        contractEngine(widget, mainpic, animpanel, 120, 120, 0, 0, 136, 196, 33, 25, 9, 6, 13, 19, -36, 36, 0)
        
    elif animstyle == 2:
        fadeOutEngine(widget, mainpic, animpanel, "ddcbg_alpha_", 33, 25, 196, 136, 0, 0, 0)
    else:
        karamba.deleteImage(widget,animpanel)
        karamba.redrawWidget(widget)
    #if animate == 0:
        #karamba.resizeImage(widget, mainpic, 120, 120)
#     karamba.removeImageTransformations(widget, mainpic)
#     karamba.redrawWidget
    abouton = 0
    otherdetail == 1

def initWidget(widget):
    global situtext, stormon, stormbutt, mapmenu, weather, daytemps, daytext, daypic, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, situation, wind_speed, mainpic, windpic, ddon, hon, hon2, dayshow, ddcon, firsthour, buttonpressed, mainpicclick,  firsttime, background, metric_units, clock, url, mainback, clicky, daypicpos, animate, windpic_bg, windspeed, windy, webpicon, webcammenu, webcamurls, webcamlabels, nowebcams, webcamsfree, path, use_wcom, wcomcode, satpicurl, cambutt, satbutt, iconset, iconsetpath, satbuttmenu, citytext, range_font, font_range, dnamobst, p, h, r, colour, altback, threadflag, delay, kxdocker, flatflag, flatstring, kxdocker_running, kxdocker_lasttime, kxdocker, otherdetail, language, countries, map_matrix, continentitems, mapitems, continentitemsconvert, mapitemsconvert, red, green, blue, colourflag, mainwtext, reddrop, greendrop, bluedrop, shadow, tooltipsat, tooltipcam, animstyle, splash, alticonsetpath, haveiconpath, tooltipp, tooltiph, tooltipr, textstyle, ddbg, ddcbg, hbg, hbg2, timegate, theme_path, hourly, base_menuime
    fadeInSplash(widget)
    webcammenu = 0
    satbuttmenu = 0
    mapmenu = 0
    optchecked = mainback
    firsttime = 0
    try:
        os.mknod(config_directory + '/theme_path')
    except(OSError):
        pass
    skz_path = open(config_directory + '/theme_path', 'w')
    skz_path.write(karamba.getThemePath(widget) +'\n')
    if karamba.getThemePath(widget)[-3:] == 'skz':
        skz_path.write('1' + '\n')
    else:
        skz_path.write('0' + '\n')
    skz_path.close()

    try:
        os.mknod(config_directory + '/test_gui.py')
        os.mknod(config_directory + '/lwp_config.py')
    except(OSError):
        pass
    if karamba.getThemePath(widget)[-3:] == 'skz':
        skz_file = zipfile.ZipFile(karamba.getThemePath(widget), 'r')
        test_gui = skz_file.read('test_gui.py')
        lwp_config = skz_file.read('lwp_config.py')
    else:
        dir_gui = open(karamba.getThemePath(widget) + '/test_gui.py','r')
        test_gui = dir_gui.read()
        dir_config = open(karamba.getThemePath(widget) + '/lwp_config.py','r')
        lwp_config = dir_config.read()
        dir_gui.close()
        dir_config.close()
    wrt_gui = open(config_directory + '/test_gui.py','w')
    wrt_config = open(config_directory + '/lwp_config.py','w')
    wrt_gui.write(test_gui)
    wrt_config.write(lwp_config)
    try:
        test_config_file = open(config_directory + '/lwp_gui_config','r')
        data = test_config_file.read()
        try:
            test = data.find('Main')
        except:
            os.remove(config_directory + 'lwp_gui_config')
        test_config_file.close()
        print "Reading config"
        getGuiConfig(widget)
    except:
        print "Skipping config read"
    karamba.changeInterval(widget,delaylist[delay])
    initTranslation(widget, language)
    try:
        from qt import *
        hasqt = 1
    except:
        os.system('kdialog --title "%s" --error "%s" &' %(_('Critical Error'),_('You do not have PyQT installed.  This is a critical dependency for Liquid Weather ++.  Please install it and try again.')))
        exit
    if os.popen('which convert').read() == '':
        os.system('kdialog --title "%s" --error "%s" &' %(_('Critical Error'),_('You do not have ImageMagick installed.  This is a critical dependency for Liquid Weather ++.  Please install it and try again.')))
        exit
    createConfigMenu(widget)

#    buttonpressed = 0
    ddcon = 0
    dayshow = 5
    ddon = 0
    hon = 0
    hon2 = 0
    otherdetail = 1
#     firsthour = 0
    webpicon = 0
#     path = karamba.getThemePath(widget)
#     path = path + "/"
#     os.chdir(path)
    testkxd = os.popen('dcop kxdocker').readlines()
    if len(testkxd) > 1:
        kxdocker_running = 1
    
    
    #iconsetpath = "liquid/"
    #if iconset == 1:
        #iconsetpath = "um/"
    #os.system("pwd")

    #karamba.redrawWidgetBackground(widget)
#    karamba.redrawWidget(widget)
    countries = ["eq", "2xus_", "2xcn_", "2xca_", "2xsa_", "2xeu_", "2xas_", "2xa2_", "2xaf_", "2xau_", "2xan_"]
    map_matrix = [['australia.html', 's_pacific.html', 'n_america.html', 's_america.html', 'asia.html', 'europe.html', 'africa.html'], ['st', 'hi', 'wc', 'rh', 'rd', 'dp', 'ws', 'vs', 'vi', 'ir', 'sf', 'snow', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'ir', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'ir', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'vi', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt'], ['st', 'hi', 'wc', 'rh', 'dp', 'ws', 'vs', 'jt']]
    #Conversion may be required, as menus crash if you do conversion on the fly
    continentitemsconvert = [_('Earthquakes'), _('United States'), _('Canada'), _('Central America'), _('South America'), _('Europe'), _('Northern Asia'), _('Southern Asia'), _('Africa'), _('Australia'), _('Antarctica')]
    continentitems = continentitemsconvert
    mapitemsconvert = [[_('Australia'), _('South Pacific'), _('North America'), _('South America'), _('Asia'), _('Europe'), _('Africa')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Radar'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Visible Satellite'), _('Satellite'), _('Fronts'), _('Snow Depth'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Visible Satellite'), _('Satellite'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Visible Satellite'), _('Satellite'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Visible Satellite'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')], [_('Temperature'), _('Heat Index'), _('Wind Chill'), _('Relative Humidity'), _('Dew Point'), _('Wind Speed'), _('Visibility'), _('Jetstream')]]
    mapitems = mapitemsconvert

    if animstyle == 2:
        globals()["bgfThread"] = fadeBG(widget)
        globals()["bgfThread"].start()
        globals()["bgfThread"] = None
    globals()["wdlThread"] = weatherDL(widget)
    globals()["wdlThread"].start()
    globals()["wdlThread"].join()
    weather = globals()["wdlThread"].w
    hourly = globals()["wdlThread"].h
    globals()["wdlThread"] = None
    timegate = time.time()
    writeGuiConfig(widget)
    if set_gui_failed == 1:
        getGuiConfig(widget)
    theme_file = open(config_directory + '/theme_path','r')
    theme_path = theme_file.readlines()
    theme_file.close()
    if use_wcom == 1:
        globals()["mnfThread"] = fadeMoon(widget)
        globals()["mnfThread"].start()
        globals()["mnfThread"] = None
    fadeOutSplash(widget)
    #karamba.deleteImage(widget,splash)
    karamba.redrawWidget(widget)
    background = karamba.createBackgroundImage(widget, 15, 15, bg)
    if flatflag == 1:
        windpic_bg = karamba.createImage(widget, 180, 62, 'wind_icons/flat/wind_bg.png')
    else:
        windpic_bg = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/wind_bg.png')
    #layout text
    p = karamba.createText(widget, 120, 58, 15, 12, "P:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, p)
    tooltipp = karamba.createImage(widget, 120, 58, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipp, _('Air Pressure'))
    h = karamba.createText(widget, 120, 70, 15, 12, "H:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, h)
    tooltiph = karamba.createImage(widget, 120, 70, "tooltip.png")
    karamba.addImageTooltip(widget, tooltiph, _('Humidity'))
    r = karamba.createText(widget, 120, 82, 15, 12, "R:")
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, r)
    tooltipr = karamba.createImage(widget, 120, 82, "tooltip.png")
    karamba.addImageTooltip(widget, tooltipr, _('Relative Temp After Windchill'))
    maintemp = karamba.createText(widget, 120, 33, 59, 30, weather.temperature())
    prettyText(widget, fontSizeMatrix[0], fontFamilyMatrix[0], shadow, maintemp)
    karamba.attachClickArea(widget, maintemp)
    situtext = _(weather.sky())
    if situtext == None:
        situtext = weather.sky()
        transError(widget, weather.sky())
    situation = karamba.createText(widget, 37, 104, 200, 18, weather.place())
    prettyText(widget, fontSizeMatrix[1], fontFamilyMatrix[1], shadow, situation)

    mainpic = karamba.createImage(widget, 0, 0, iconsetpath + weather.icon_path())
    karamba.attachClickArea(widget, mainpic)
    karamba.addImageTooltip(widget, mainpic, situtext)


    pnum = karamba.createText(widget, 135, 58, 75, 12, weather.pressure())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, pnum)
    hnum = karamba.createText(widget, 135, 70, 30, 12, weather.humidity())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, hnum)
    rnum = karamba.createText(widget, 135, 82, 30, 12, weather.relative_heat())
    prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, rnum)
    windicon = weather.wind_icon_path()
    if flatflag == 1:
        windspeed = karamba.createText(widget, 182, 107, 40, 15, weather.wind_speed())
    else:
        windspeed = karamba.createText(widget, 182, 94, 40, 15, weather.wind_speed())
    prettyText(widget, fontSizeMatrix[2] - 1 , fontFamilyMatrix[2], shadow, windspeed)
    if flatflag == 1:
        windpic = karamba.createImage(widget, 180, 62, 'wind_icons/flat/' + windicon)
    else:
        windpic = karamba.createImage(widget, 186, 70, 'wind_icons/liquid/' + windicon)

    xstart = 37
    daytextrem = []
    daytempsrem = []
    daypicrem = []
    daypicpos = []
    base_menuime = int(weather.time()[:2])
    for i in range(0,5):
        if i == 0:
            if base_menuime >= 14:
                sep = weather.get_forecast(i).temp_range().find('/')
                daytext = karamba.createText(widget, xstart, 125, 40, 12, _("2nite") + ':')
                daytemps = karamba.createText(widget, xstart, 168, 40, 12, _("Lo:") + weather.get_forecast(i).temp_range()[:sep])
            else:
                daytext = karamba.createText(widget, xstart, 125, 40, 12, _("2day") + ':')
                daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        else:
            daytext = karamba.createText(widget, xstart, 125, 40, 12, _(weather.get_forecast(i).weekday()) + ":")
            daytemps = karamba.createText(widget, xstart, 168, 40, 12, weather.get_forecast(i).temp_range())
        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytext)
        daytextrem.append(daytext)

        prettyText(widget, fontSizeMatrix[2], fontFamilyMatrix[2], shadow, daytemps)
        daytempsrem.append(daytemps)
        daypic = karamba.createImage(widget, (xstart + 5), 140, iconsetpath + weather.get_forecast(i).icon_path())
        karamba.attachClickArea(widget, daypic)
        if (i == 0) and (use_wcom == 1):
            karamba.addImageTooltip(widget,daypic,_("Left click shows today's forecast - Middle click for hourly forecast"))
        daypicrem.append(daypic)
        daypicpos.append(xstart + 5)
        xstart = xstart + 39
    satbutt = karamba.createImage(widget, 179, 36, 'satbutton' + flatstring + '.png')
    karamba.attachClickArea(widget, satbutt)
    karamba.addImageTooltip(widget, satbutt, _('Weather Maps'))
    cambutt = karamba.createImage(widget, 203, 36, 'webcambutton' + flatstring + '.png')
    karamba.attachClickArea(widget, cambutt)
    karamba.addImageTooltip(widget, cambutt, _('Webcams'))
    if stormFlag == 1:
        stormon = 1
        karamba.deleteImage(widget, satbutt)
        karamba.redrawWidget(widget)
        stormbutt = karamba.createImage(widget, 179, 36, 'storm.png')
        karamba.attachClickArea(widget, stormbutt)
        karamba.redrawWidget(widget)
    mainwtext = [p, h, r, maintemp, situation, pnum, hnum, rnum, daytextrem[0], daytextrem[1], daytextrem[2], daytextrem[3], daytextrem[4], daytempsrem[0], daytempsrem[1], daytempsrem[2], daytempsrem[3],daytempsrem[4], windspeed]
    karamba.translateAll(widget, -240, 0)
    for i in range(24):
        karamba.translateAll(widget, 10, 0)
        karamba.redrawWidget(widget)
    karamba.redrawWidget(widget)
    if (kxdocker_running == 1) and (kxdocker == 1):
        globals()["kxdThread"] = initBeginKxdocker(widget)
        globals()["kxdThread"].start()

        kxdocker_lasttime = 1
    firsttime = 1
#this is called everytime your widget is updated
#the update inverval is specified in the .theme filed
def widgetUpdated(widget):
    global situtext, stormFlag, stormon, stormbutt, weather, daytempsrem, daytextrem, daypicrem, maintemp, pnum, hnum, rnum, situation, wind_speed, mainpic, daytext, daytemps, daypics, windpic, windpic_bg, buttonpressed, backgroud, timegate, configchange, firsttime, clicky, daypicpos, windspeed, werethreading, satbutt, cambutt, windpic_bg, flatflag, windspeed, kxdocker_running, kxdocker_lasttime, kxdocker, data_updated, configchange, gui_file_stat, hourly
    
    if (configchange == 1) and globals()["wdlThread"] == None:
        karamba.changeText(widget,situation,_('Fetching data ...'))
        karamba.redrawWidget(widget)
        data_updated = 1
        configchange = 0
        karamba.changeInterval(widget,1000)
        globals()["wdlThread"] = weatherDL(widget)
        globals()["wdlThread"].start()
        
        
    elif ((globals()['wdlThread'] == None) or not globals()['wdlThread'].isAlive()) and (data_updated == 1):
        #if not globals()['wdlThread'].isAlive():
        if globals()["wdlThread"] != None:
            weather = globals()["wdlThread"].w
            hourly = globals()["wdlThread"].h
            globals()["wdlThread"] = None
            timegate = time.time()
        resetWidget(widget)
        data_updated = 0
        karamba.changeInterval(widget,delaylist[delay])
    elif (gui_on == 1) and (os.stat(config_directory + '/lwp_gui_config').st_mtime > gui_file_stat.st_mtime):
        gui_file_stat = os.stat(config_directory + '/lwp_gui_config')
        from ConfigParser import RawConfigParser
        config = RawConfigParser()
        config.read(config_directory + '/lwp_gui_config')
        config_change = config.getint('Main','change_flag')
        if (config_change == 1) and (globals()['wdlThread'] == None):
            resetWidget(widget)
        else:
            pass
    elif (gui_on == 0) and ((globals()["wdlThread"] == None) or (not globals()['wdlThread'].isAlive())):
        karamba.changeText(widget,situation,_('Fetching data ...'))
        karamba.redrawWidget(widget)
        data_updated = 1
        karamba.changeInterval(widget,1000)
        globals()["wdlThread"] = weatherDL(widget)
        globals()["wdlThread"].start()
        

    else:
        pass
    
def widgetClicked(widget, x, y, button):
    global clicky, dayshow, buttonpressed, oldday
    pass

def widgetMouseMoved(widget, x, y, button):
    #Warning:  Don't do anything too intensive here
    #You don't want to run some complex piece of code everytime the mouse moves
    pass

def meterClicked(widget, meter, button):
    global dayshow, daypicrem, ddon, ddcon, buttonpressed, clicky, mapmenu, selection, webcammenu, satbuttmenu, satfilenames, hon, hon2, otherdetail, UI, configchange, abouton
    satfilenames = [installed + '/satpic.jpg', installed + '/summap.jpg', installed + '/pressmap.jpg']
    selection = []
    try:
        if (meter == stormbutt) and (button == 2):
            os.system('konqueror %s &' %('http://www.solar.ifa.hawaii.edu/Tropical/'))
    except:
        pass
    if (meter == maintemp) and (button ==1):
        if UI == 'simple':
            UI = 'complex'
            configchange = 0
            changeToComplex(widget)
        elif UI == 'complex':
            UI = 'simple'
            configchange = 0
            changeToSimple(widget)
        else:
            pass
    elif (meter == cambutt) and (button == 2) and (webpicon == 1):
        karamba.changeImageIntensity(widget, animpanel, 0.4, 300)
        karamba.redrawWidget(widget)
        os.system('kview %s &' %(filename))
        removeWebcamPic(widget)
    elif (meter == satbutt) and (button == 2) and (satpicon == 1):
        karamba.changeImageIntensity(widget, animpanel, 0.4, 300)
        karamba.redrawWidget(widget)
        os.system('kview %s &' %(satfile))
        removeSatPic(widget)
    elif (meter == cambutt) and (button == 1):
        if (webpicon == 0) and (satpicon == 0) and (ddcon == 0) and (ddon == 0) and (hon == 0):
            karamba.deleteMenu(widget, webcammenu)
            karamba.deleteMenu(widget, satbuttmenu)
            satbuttmenu = 0
            webcammenu = karamba.createMenu(widget)
            for i in range(len(webcamlabels)):
                item = karamba.addMenuItem(widget, webcammenu, webcamlabels[i], "")
                #sorts out the id of the item clicked so it's useful
                #id seems to be negative value, convert to positive
                if item < 0:
                    item = item * -1
                selection.append(item)
            karamba.popupMenu(widget, webcammenu, 30, 56)
        elif (webpicon == 1):
            removeWebcamPic(widget)
            karamba.redrawWidget(widget)
        else:
            pass
    elif (meter == satbutt) and (button == 1):
        if (webpicon == 0) and (satpicon == 0) and (ddcon == 0) and (ddon == 0) and (hon == 0):
            karamba.deleteMenu(widget, satbuttmenu)
            karamba.deleteMenu(widget, webcammenu)
            webcammenu = 0
            mapmenu = 0
            satbuttmenu = karamba.createMenu(widget)
            for i in range(len(continentitems)):
                item = karamba.addMenuItem(widget, satbuttmenu, continentitemsconvert[i], "")
                #sorts out the id of the item clicked so it's useful
                #id seems to be negative value, convert to positive
                if item < 0:
                    item = item * -1
                selection.append(item)
            karamba.popupMenu(widget, satbuttmenu, 30, 56)
        elif (webpicon == 1):
            removeWebcamPic(widget)
            karamba.redrawWidget(widget)
        elif (satpicon == 1):
            removeSatPic(widget)
            karamba.redrawWidget(widget)
        else:
            pass
    elif (meter == mainpic) and (button == 2) and (use_wcom == 1):
        if moonon == 0:
            showMoon(widget, UI)
        elif moonon == 1:
            showMain(widget, UI)
    elif (meter == mainpic) and (button == 1) and (moonon == 0):
        if ddcon == 0:
            if hon == 1:
                deleteHourlyDetail1(widget)
                karamba.redrawWidget(widget)
            elif hon2 == 1:
                deleteHourlyDetail2(widget)
                karamba.redrawWidget(widget)
            elif ddon == 1:
                if use_wcom ==0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            elif abouton == 1:
                deleteAbout(widget)
                karamba.redrawWidget(widget)
            createCurrentDetail(widget)
            karamba.redrawWidget(widget)
        else:
            deleteCurrentDetail(widget)
    elif (meter == daypicrem[0]) and (button == 2):
        if use_wcom == 0:
            pass
        elif hon == 0 and hon2 ==0 and otherdetail == 1:
            if ddcon == 1:
                deleteCurrentDetail(widget)
                karamba.redrawWidget(widget)
            elif ddon == 1:
                if use_wcom == 0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            elif abouton == 1:
                deleteAbout(widget)
                karamba.redrawWidget(widget)
            createHourlyDetail1(widget)
            karamba.redrawWidget(widget)
        elif hon == 1:
            deleteHourlyDetail1(widget)
        elif hon2 == 0 and hon == 0 and otherdetail == 0:
            if ddcon == 1:
                deleteCurrentDetail(widget)
                karamba.redrawWidget(widget)
            elif ddon == 1:
                if use_wcom == 0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            elif abouton == 1:
                deleteAbout(widget)
                karamba.redrawWidget(widget)
            createHourlyDetail2(widget)
            karamba.redrawWidget(widget)
        elif hon2 == 1:
            deleteHourlyDetail2(widget)

    #elif (meter == mainpic) and (button == 2):
        #if webpicon == 0:
            #if ddcon == 1:
                #deleteCurrentDetail(widget)
                #karamba.redrawWidget(widget)
            #elif ddon == 1:
                #deleteDayDetail(widget, dayshow)
                #karamba.redrawWidget(widget)
            #showWebcamPic(widget)
            #karamba.redrawWidget(widget)
        #else:
            #removeWebcamPic(widget)
    else:
        for i in range(0,5):
            if (meter == daypicrem[i]) and (button == 1) and (dayshow != i):
                if ddon == 1:
                    if use_wcom == 0:
                        deleteBBCDayDetail(widget, dayshow)
                    else:
                        deleteWcomDayDetail(widget, dayshow)
                    karamba.redrawWidget(widget)
                elif ddcon == 1:
                    deleteCurrentDetail(widget)
                    karamba.redrawWidget(widget)
                elif hon == 1:
                    deleteHourlyDetail1(widget)
                    karamba.redrawWidget(widget)
                elif hon2 == 1:
                    deleteHourlyDetail2(widget)
                    karamba.redrawWidget(widget)
                elif webpicon == 1:
                    removeWebcamPic(widget)
                    karamba.redrawWidget(widget)
                elif satpicon == 1:
                    removeSatPic(widget)
                    karamba.redrawWidget(widget)
                elif abouton == 1:
                    deleteAbout(widget)
                    karamba.redrawWidget(widget)
                if use_wcom == 0:
                    createBBCDayDetail(widget, i)
                else:
                    createWcomDayDetail(widget, i)
                karamba.redrawWidget(widget)
                dayshow = i
                break
            if (meter == daypicrem[i]) and (button == 1) and (dayshow == i):
                if ddon == 1:
                    if use_wcom == 0:
                        deleteBBCDayDetail(widget, dayshow)
                    else:
                        deleteWcomDayDetail(widget, dayshow)
                    karamba.redrawWidget(widget)
                elif hon == 1:
                    deleteHourlyDetail1(widget)
                    karamba.redrawWidget(widget)
                elif hon2 ==1:
                    deleteHourlyDetail2(widget)
                    karamba.redrawWidget(widget)
                elif ddon == 0:
                    if use_wcom == 0:
                        createBBCDayDetail(widget, i)
                    else:
                        createWcomDayDetail(widget, i)
                    karamba.redrawWidget(widget)
                elif ddcon == 1:
                    deleteCurrentDetail(widget)
                    karamba.redrawWidget(widget)
                elif webpicon == 1:
                    removeWebcamPic(widget)
                    karamba.redrawWidget(widget)
                elif satpicon == 1:
                    removeSatPic(widget)
                    karamba.redrawWidget(widget)
                elif abouton == 1:
                    deleteAbout(widget)
                    karamba.redrawWidget(widget)
                dayshow = i
                break
##    buttonpressed = 1

def menuItemClicked(widget, menu, id):
    global webcamdisplay, whichone, whichcontinent, eqflag
    id = id * -1
    if menu == webcammenu:
        getWebcamPic(widget, selection.index(id))
        webcamdisplay = selection.index(id)
        showWebcamPic(widget)
    if menu == satbuttmenu:
        whichone = selection.index(id)
        createMapMenu(widget, whichone)
        whichcontinent = whichone
        if whichone == 0:
            eqflag = 1
        else: 
            eqflag = 0
    if menu == mapmenu:
        whichone = selection.index(id)
        if eqflag == 1:
            showEq(widget, whichone)
        else:
            getSatPic(widget, whichcontinent, whichone)
            showSatPic(widget)
#This gets called when an item is clicked in the theme CONFIGURATION menu,
#not the popup menus that you create.
#  key = the reference to the configuration key that was changed
#  value = the new value (true or false) that was selected
def menuOptionChanged(widget, key, value):
    global clock, metric_units, url, url_base_addr, configchange, mainback, background, animate, bkgdpid, locpid, wcompid, bbcpid, searchsite, wcomcodespid, bbccodespid, windy, webcamurlpid, remwebcampid, webcamlabelpid, iconset, contpid, werethreading, iconpid, range_font, font_range, threadflag, dnamobst, delaypid, kxdocker, kxdocker_lasttime, language, translationpid, colourpid, dropcolorpid, shadow, animstylepid, encoding, iconpathpid, csconf, current, loop, configpid, textstyle, gui_on, gui_file_stat, use_wcom, wcomcode, bbc_code, url
    
    if key == 'separator':
        karamba.setMenuConfigOption(widget,'separator',0)
    elif key == 'separator1':
        karamba.setMenuConfigOption(widget,'separator1',0)
    elif key == 'help':
        karamba.setMenuConfigOption(widget,'help',0)
        os.system('konqueror "http://liquidweather.net/manual.html" &')
    elif key == 'about':
        karamba.setMenuConfigOption(widget,'about',0)
        if abouton == 0:
            if ddcon ==1:
                deleteCurrentDetail(widget)
            elif hon == 1:
                deleteHourlyDetail1(widget)
                karamba.redrawWidget(widget)
            elif hon2 == 1:
                deleteHourlyDetail2(widget)
                karamba.redrawWidget(widget)
            elif ddon == 1:
                if use_wcom ==0:
                    deleteBBCDayDetail(widget, dayshow)
                else:
                    deleteWcomDayDetail(widget, dayshow)
                karamba.redrawWidget(widget)
            elif webpicon == 1:
                removeWebcamPic(widget)
                karamba.redrawWidget(widget)
            elif satpicon == 1:
                removeSatPic(widget)
                karamba.redrawWidget(widget)
            showAbout(widget)
            karamba.redrawWidget(widget)
        else:
            deleteAbout(widget)

    elif key.find('entry') == 0:
        item = int(key[5:])
        for i in range(len(cities)):
            entryName = 'entry' + str(i)
            karamba.setMenuConfigOption(widget, entryName, 0)
            if i == item:
                karamba.setMenuConfigOption(widget, entryName, 1)
        if len(codes[item]) < 5:
            url = url= url_bbc_base_addr + codes[item] + url_bbc_add_addr
            use_wcom = 0
            bbc_code = codes[item]
        else:
            url = url_base_addr + codes[item] + url_suffix
            use_wcom = 1
            wcomcode = codes[item]
        from ConfigParser import RawConfigParser
        config = RawConfigParser()
        config.read(config_directory + '/lwp_gui_config')
        config.set('Main','code',codes[item])
        config.set('Main','city',cities[item])
        temp_file = open(config_directory + '/lwp_gui_config','w')
        config.write(temp_file)
        temp_file.close()
        configchange = 1
        initTranslation(widget, language)
        widgetUpdated(widget)
    else:
        if haveiconpath == 1:
            icopath = alticonsetpath
        else:
            icopath = ''
        if use_wcom == 1:
            loccode = wcomcode
        else:
            loccode = url[52:56]
        try:
            os.mknod(config_directory + '/theme_path')
        except(OSError):
            pass
        skz_path = open(config_directory + '/theme_path', 'w')
        skz_path.write(karamba.getThemePath(widget) +'\n')
        if karamba.getThemePath(widget)[-3:] == 'skz':
            skz_path.write('1' + '\n')
        else:
            skz_path.write('0' + '\n')
        if language != '':
            skz_path.write(language)
        else:
            skz_path.write('no_lang')
        skz_path.close()
    
        
        configpid = None
        configcommand = ["python", config_directory + '/test_gui.py']
        if (key == "config_gui"):
            karamba.changeInterval(widget,1000)
            gui_on = 1
            gui_file_stat = os.stat(config_directory + '/lwp_gui_config')
            karamba.setMenuConfigOption(widget, "config_gui",0)
            configpid = karamba.executeInteractive(widget, configcommand)

#This gets called when a command you have executed with executeInteractive() outputs something
#to stdout.  This way you can get the output of for example kdialog without freezing up the widget
#waiting for kdialog to end.
#  widget = reference to your theme
#  pid = process number of the program outputting (use this if you execute more than out process)
#  output = the text the program outputted to stdout
def commandOutput(widget, pid, output):
    global bkgdpid, locpid, wcompid, bbcpid, mainback, background, configchange, url, url_base_addr, url_bbc_base_addr, searchsite, city, url_webcam, webcamlabelpid, nowebcams, webcamlabels, webcamurls, webcamsfree, use_wcom, wcomcode, satpicurl, werethreading, iconset, iconsetpath, colour, altback, windpic_bg, delay, flatflag, flatstring, language, red, green, blue, colourflag, reddrop, greendrop, bluedrop, animstyle, alticonsetpath, haveiconpath, ddcbg, ddbg, hbg, hbg2, gui_on

    # DAVE
    
    if pid == configpid:
        getGuiConfig(widget)
        # DAVE
        #os.remove(config_directory + '/cam_labs')
        #os.remove(config_directory + '/cam_urls')
        #os.remove(config_directory + '/colours')
        try:
            os.remove(config_directory + '/locale/' + language + '/LC_MESSAGES/liquid_weather.mo')
            os.removedirs(config_directory + '/locale/' + language + '/LC_MESSAGES')
#         os.remove(home_directory + '/.superkaramba/theme_path')
        except:
            pass
        gui_on = 0
        from ConfigParser import RawConfigParser
        config = RawConfigParser()
        config.read(config_directory + '/lwp_gui_config')

        # DAVE
        try:
            config_change = config.getint('Main','change_flag')
        except:
            # Do something here!
            pass
        
        #karamba.changeInterval(widget,delaylist[delay])
        if (config_change == 1) and (globals()['wdlThread'] == None):
            karamba.changeInterval(widget,delaylist[delay])
            resetWidget(widget)
        elif config_change == 3:
            config.set('Main','change_flag','1')
            temp_file = open(config_directory + '/lwp_gui_config','w')
            config.write(temp_file)
            temp_file.close()
            karamba.reloadTheme(widget)
        else:
            configchange = 1
            initTranslation(widget, language)
            widgetUpdated(widget)


